/*
 * Mocha
 * Copyright (c) 2002 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */


#ifndef _IMG_ECOM_H_
#define _IMG_ECOM_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/*
 * ECOM Interface
 */
ECOM_INTERFACE(EImgCODEC)
{
	DECLARE_EBASE()

	BOOL	(*DecodeImage)(ImgCodecType type, ImgImage* pImage, unsigned char* pRawData, ULONG dataSize);
	BOOL	(*EncodeImage)(ImgCodecType type, ImgImage* pImage, unsigned char** pRawData, ULONG* pDataSize, int encodeQuality);
	BOOL    (*FreeImage)(ImgImage* pImage);
	BOOL	(*DecodeFileEx)(const char* szFileName, ImgImage **ppImage, unsigned int width, unsigned int height, ImgInputFlag inputFlag,ImgResizeInput	resize);
	BOOL			(*GIFDecodeNextFrame)	(ImgImage *pImage, unsigned char *pData, INT32 cFileSize);
	unsigned int	(*GetMemoryRequired)	(unsigned char *pImage,ULONG size,   unsigned int  *pImageWidth,   unsigned int *pImageHeight,  unsigned int *pFrames);
	ImgCodecType	(*GetDataCodecType)		(unsigned char* pEncodedData); 
	BOOL 			(*DecodeImageScaled)	(ImgCodecType type, unsigned char *pEncodedData, unsigned int eWidth, unsigned int eHeight, ImgImage *pImage, ULONG dataSize, ImgInputFlag inputFlag, ImgResizeInput resize);

};

/*
 * Interface Accessor
 */
// Native/DLL Call
#if (defined(_SHP_SIMUL) && defined(_SHP_CALL_DLL_IMGCODEC)) || (defined(_SHP_DLL) && ! defined(_SHP_DLL_IMGCODEC) && ! defined(_SHP_CALL_DLL_IMGCODEC))
#	define ImgDispatch 	(__ImgGetVtbl()->Dispatch)
#	define ImgDecodeImage		(__ImgGetVtbl()->DecodeImage)
#	define ImgEncodeImage		(__ImgGetVtbl()->EncodeImage)
#	define ImgFreeImage			(__ImgGetVtbl()->FreeImage)
#	define ImgDecodeFileEx		(__ImgGetVtbl()->DecodeFileEx)
// Zafar ECOM
#	define ImgGIFDecodeNextFrame			(__ImgGetVtbl()->GIFDecodeNextFrame)
#	define ImgGetMemoryRequired				(__ImgGetVtbl()->GetMemoryRequired)
#	define ImgGetDataCodecType				(__ImgGetVtbl()->GetDataCodecType)
#	define ImgDecodeImageScaled				(__ImgGetVtbl()->DecodeImageScaled)

#endif // _SHP_DLL

/*
 * ECOM Type
 */
typedef struct
{
	DECLARE_ECOM_VTBL(EImgCODEC)
	UINT32		refCount;
} TImgCODEC;

extern TImgCODEC	imgCODEC;


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _IMG_ECOM_H_
