/*
 * Mocha 
 * Copyright (c) 2005 IT Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file AppSndVib.h
 *
 * This file implements the APIs of Application Sound Manager.
 *
 * @author	mobum
 */
/*:Associate with "Application Sound Manager" */

#ifndef _APP_SND_VIB_H_
#define _APP_SND_VIB_H_

/**
 @struct AppSndVibInfo

 @brief Vib information
 */
typedef struct
{
	int		nPlayCount;
} AppSndVibUserInfo;

/**
 @struct AppSndVibInfo

 @brief Vib information
 */
typedef struct
{
	HObj	hVib;
} AppSndVibInfo;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * Public Function Prototypes
 */
 
// Local calls
#if defined(_SHP_DLL_APPSNDMGR) || ( ! defined(_SHP_DLL) && ! defined(_SHP_CALL_DLL_APPSNDMGR))

// Play/Stop
BOOL	AppSndPlayVib			( AppSndVibType iVibType );
BOOL	AppSndStopVib			( AppSndVibType iVibType );

// Set
BOOL	AppSndSetVibIntensity	( AppSndVibType iVibType, int nIntensity );
BOOL	AppSndSetVibCount		( AppSndVibType iVibType, int nPlayCount );

#endif // defined(_SHP_DLL_APPSNDMGR) || ( ! defined(_SHP_DLL) && ! defined(_SHP_CALL_DLL_APPSNDMGR))

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _APP_SND_VIB_H_
