/*
 * Mocha
 * Copyright (c) 2000-2003 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */

/*:Associate with "Device Manager" */

#ifndef _DEV_PHONE_STATUS_ECOM_H_
#define _DEV_PHONE_STATUS_ECOM_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * ECOM Interface
 */
ECOM_INTERFACE(EDevPhoneStatus)
{
	DECLARE_EBASE()

	void	(*SetStatus)(PhoneStatusType type, int value);
	int		(*GetStatus)(PhoneStatusType type);
	BOOL	(*GetDebugState)(void);
	void	(*SetDebugState)(BOOL bDebug);
	void	(*GetPhoneNumber)(int ith, char* szHyphenNumber);
	void	(*SetPhoneNumber)(int ith, char* szHyphenNumber);

	void	(*SetIdleState)(BOOL bIdle);
	BOOL	(*IsIdleState)(void);

	void	(*SetNetAppStatus)(PhsNetAppList id, PhsNetAppType value);
	void	(*SetNetAppExStatus)(PhsNetAppList id, PhsNetAppExType value);
	PhsNetAppType		(*GetNetAppStatus)(PhsNetAppList id);
	PhsNetAppExType		(*GetNetAppExStatus)(PhsNetAppList id);

	void	(*HfkReadStatus)(void);
	int		(*HfkGetStatus)(HfkStatusType type);

	BOOL	(*IsDevInserted)(PhoneStatusDevType type);
	
	void		(*SetLoudSpeaker)(BOOL bOn);
	BOOL	(*IsLoudSpeaker)(void);
	BOOL	(*IsLowBattery)(void);
};

/*
 * Interface Accessor
 */

// Native/DLL Call
#if (defined(_SHP_SIMUL) && defined(_SHP_CALL_DLL_DEVMGR_DEVPHONESTATUS)) || (defined(_SHP_DLL) && ! defined(_SHP_DLL_DEVMGR_DEVPHONESTATUS) && ! defined(_SHP_CALL_DLL_DEVMGR_DEVPHONESTATUS))
#	define PhsSetStatus				(__PhsGetVtbl()->SetStatus)
#	define PhsGetStatus				(__PhsGetVtbl()->GetStatus)
#	define PhsGetDebugState			(__PhsGetVtbl()->GetDebugState)
#	define PhsSetDebugState			(__PhsGetVtbl()->SetDebugState)
#	define PhsGetPhoneNumber		(__PhsGetVtbl()->GetPhoneNumber)
#	define PhsSetPhoneNumber		(__PhsGetVtbl()->SetPhoneNumber)
#	define PhsSetIdleState			(__PhsGetVtbl()->SetIdleState)
#	define PhsIsIdleState				(__PhsGetVtbl()->IsIdleState)
#	define PhsHfkReadStatus			(__PhsGetVtbl()->HfkReadStatus)
#	define PhsHfkGetStatus			(__PhsGetVtbl()->HfkGetStatus)
#	define PhsIsDevInserted			(__PhsGetVtbl()->IsDevInserted)
#	define PhsSetNetAppStatus		(__PhsGetVtbl()->SetNetAppStatus)
#	define PhsSetNetAppExStatus		(__PhsGetVtbl()->SetNetAppExStatus)
#	define PhsGetNetAppStatus		(__PhsGetVtbl()->GetNetAppStatus)
#	define PhsGetNetAppExStatus		(__PhsGetVtbl()->GetNetAppExStatus)
#	define PhsSetLoudSpeaker		(__PhsGetVtbl()->SetLoudSpeaker)
#	define PhsIsLoudSpeaker			(__PhsGetVtbl()->IsLoudSpeaker)
#	define PhsIsLowBattery			(__PhsGetVtbl()->IsLowBattery)
#endif // _SHP_DLL


/*
 * ECOM Type
 */
typedef struct
{
	DECLARE_ECOM_VTBL(EDevPhoneStatus)
	UINT32		refCount;
} TDevPhoneStatus;

extern TDevPhoneStatus devPhs;

#ifdef __cplusplus
}
#endif  /* __cplusplus */

#endif // _DEV_PHONE_STATUS_ECOM_H_
