/*
 * Mocha
 * Copyright (c) 2000-2003 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */

/*:Associate with "Device Manager" */

#ifndef _DEV_SOUND_H_
#define _DEV_SOUND_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


typedef struct
{
	UINT16		toneDbId;	
	UINT16		duration;
} SndDtmfToneInfo;

typedef struct
{
	UINT16		dtmfHiFreq;
	UINT16		dtmfLowFreq;
	UINT16		duration;
} SndDtmfToneFreqInfo;

typedef union
{
  UINT16    duration;		/* Duration in milliseconds */
  UINT16    data;			/* general purpose data     */
} SndToneDataType;

typedef struct 
{
 	UINT16      		tone;				/* Tone/DTMF to generate        */
	SndToneDataType 	toneDataType;		/* Tone data                    */
	UINT16              dtmfHiFreq;			/* High frequency value in hz   */
	UINT16              dtmfLowFreq;		/* Low frequency value in hz    */
} SndDtmfToneFlexInfo;

typedef UINT16 SndDtmfSoundIDInfo;

typedef struct
{
	int 		dataSize;
	char*		pData;
} SndSound;

typedef enum
{
	SND_OUT_DEFAULT		= 0x0000,
	SND_OUT_HFK			= 0x0001,
	SND_OUT_EARPHONE		= 0x0002,
	SND_OUT_SPEAKER		= 0x0004,
	SND_OUT_RECEIVER		= 0x0008,	
	SND_OUT_PHONE			= 0x0010,	    // receiver, speaker  
	SND_OUT_BT_HEADSET	= 0x0020,
	SND_OUT_SOUNDMATE	= 0x0040,
	SND_OUT_TTY			= 0x0080,
	SND_OUT_LINEOUT		= 0x0100
}SndOutDevPath;


#ifdef __cplusplus
}
#endif	/* __cplusplus */

#endif // _DEV_SOUND_H_



