/*
 * Mocha
 * Copyright (c) 2000-2003 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */

/*:Associate with "Non-volatile Manager" */

#ifndef	_NV_ECOM_H_
#define _NV_ECOM_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * ECOM Interface
 */
ECOM_INTERFACE(ENvMgr)
{
	DECLARE_EBASE()

	int	 (*GetInt)(int nvItemId);
	void (*GetString)(int nvItemId, char* pszBuf);
	void (*GetLongString)(int nvItemId, char* pszBuf);
	BOOL (*SetInt)(int nvItemId, int value);
	BOOL (*SetString)(int nvItemId, const char* pszBuf);
	BOOL (*SetLongString)(int nvItemId, const char* pszBuf);
	BOOL (*Flush)(void);
	BOOL (*WriteInt)(int nvItemId, int value);
	BOOL (*WriteString)(int nvItemId, const char* pszBuf);
	BOOL (*WriteLongString)(int nvItemId, const char* pszBuf);
	
	BOOL (*Load)(char *szFileName);
};

/*
 * Interface Accessor
 */

// Native/DLL Call
#if (defined(_SHP_SIMUL) && defined(_SHP_CALL_DLL_NVMGR)) || (defined(_SHP_DLL) && ! defined(_SHP_DLL_NVMGR) && ! defined(_SHP_CALL_DLL_NVMGR))
#	define NvDispatch 		(__NvGetVtbl()->Dispatch)
#	define NvGetInt			(__NvGetVtbl()->GetInt)
#	define NvGetString		(__NvGetVtbl()->GetString)
#	define NvGetLongString	(__NvGetVtbl()->GetLongString)
#	define NvSetInt			(__NvGetVtbl()->SetInt)
#	define NvSetString		(__NvGetVtbl()->SetString)
#	define NvSetLongString	(__NvGetVtbl()->SetLongString)
#	define NvFlush			(__NvGetVtbl()->Flush)
#	define NvWriteInt		(__NvGetVtbl()->WriteInt)
#	define NvWriteString	(__NvGetVtbl()->WriteString)
#	define NvWriteLongString (__NvGetVtbl()->WriteLongString)
#	define NvLoad			(__NvGetVtbl()->Load)
#endif // _SHP_DLL


/*
 * ECOM Type
 */
typedef struct
{
	DECLARE_ECOM_VTBL(ENvMgr)
	UINT32		refCount;
} TNvMgr;

extern TNvMgr nvMgr;


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	// _NV_ECOM_H_
