/*
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */

/*:Associate with "Memory Manager" */

#ifndef	_OEM_MEM_MGR_H_
#define _OEM_MEM_MGR_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "Shp.h"

typedef struct _MemStat
{
	/*
	 * Public
	 */
	UINT32	totalHeapSize;				/**<Total (Initial) heap size*/
	UINT32	totalAllocatedMemSize;		/**<Total (successfully-)allocated memory size*/
	UINT32	totalFreedMemSize;			/**<Total freed memory size*/
	UINT32	currentlyAllocatedMemSize;	/**<Currently-allocated memory size*/
} MemStat;

/*
 * Type of Heaps
 */
typedef enum
{
	HEAP_APP		= 0,
	HEAP_COUNT_MAX
} HeapType;


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	// _OEM_MEM_MGR_H_
