/*
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 *
 * @author	Li Chaehwan (chaehwan.li@samsung.com)
 */

#ifndef _BR_CONFIG_H_
#define _BR_CONFIG_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "ShpConfig.h"


// move BrCoreControlInitialize
#define	  BR_APP_NAME		"Browser"	// chaehwan 20051227 


#if defined ( _SHP_SIMUL )
#	define	_BROWSER_SIMUL
#endif // ( _SHP_SIMUL )


/*============================================================================================
	Solution definition
=============================================================================================*/
#if defined ( _SHP_BROWSER_SMB )
#	define	_BROWSER_SAMSUNG

#elif defined ( _SHP_BROWSER_OPERA )
#	define	_BROWSER_OPERA

#elif defined ( _SHP_BROWSER_NF )
#	define	_BROWSER_NETFRONT
#elif defined ( _SHP_BROWSER_SFB )
#	define	_BROWSER_JASMINE
	
#elif defined ( _SHP_BROWSER_OPW )
#	define	_BROWSER_OPENWAVE
#endif





#if defined ( _SHP_WIDGET )
#	if defined( _BROWSER_NETFRONT )
#		define	_BROWSER_WIDGET
#	elif defined( _BROWSER_JASMINE )
#		define	_BROWSER_JASMINE_WIDGET
#	endif //
#endif //_SHP_WIDGET 


#if defined ( _BROWSER_WIDGET )
#	define	_BROWSER_SEPARATE_FRAMEWORK
#	define	_BROWSER_MULTI_WINDOW_LIB	// ߿  enableŰ ￹

#	define	_BROWSER_WIDGET_ARGB_GC
#endif // _SHP_WIDGET



/*============================================================================================
	Operator settings and features
=============================================================================================*/
/**
 *  Operator Defines
 * _BROWSER_HARDKEY_URL : phone idle ¿ RSK   ǵǾ ְ,
 *                        Operator  vodafone ó ǥ URL ִ 쿡
 *                        define ؼ . refer to BrAppRequest()
 * _BROWSER_STATIC_APN  : T-Mobile 쿡 t-zones, web&walk ϶, 1 APN ؾ.
 */
#if (  defined ( _SHP_OPERATOR_VODAFONE ) || defined ( _SHP_OPERATOR_VODAFONE_VANILLA ) || defined ( _SHP_OPERATOR_VODAFONE_LITE ) )
#	define	_BR_OPERATOR_VODAFONE
#	define  _BROWSER_HARDKEY_URL	"http://live.vodafone.com"
#	define	_BROWSER_STATIC_APN		-1
#	define	_BROWSER_DISABLED_LOGO_IMAGE
#	define	_BROWSER_FEATURE_LAST_VIEWED_PAGE
#	define _BROWSER_NOT_SUPPORT_SFRMODE

// Added by jykorea. 2007.01.24		
#	define	_BROWSER_VSSCACHE_CLEAR_DISABLE

// Added by bkwoo. 2007.01.18
// Modified by yj.kim 2008.10.14 ⺻ feature Ǯ .
#	define _BROWSER_SUPPORT_DEFAULT_DOWNLOAD_STORAGE	// Vodafone  Phone setting Default  Storage  Ѵ.  

// Vodafone requirement . added by smart.yj.kim 2007-04-04
#	define	_BROWSER_REMOVE_CHECKING_WINDOW
#	define	_BROWSER_REMOVE_INFORMATION_WINDOW
#	define	_BROWSER_REMOVE_SAVING_WINDOW
#	define	_BROWSER_REMOVE_NOTIFYING_WINDOW	
//#	define	_BROWSER_VODAFONE_IMAGE_UI

#	define	_BROWSER_AUTO_RUN_JAVA		// Added by yoonjeong. 2006.12.21. AUTO RUN  Java launch ϰ . 
#	define	_BROWSER_ENABLE_PAGE_PILOT	// PagePilot  
#	define	_BROWSER_VIRTUAL_POINTER	// Added by yoonjeong. 2007.01.03. Virtual Pointer  
//#	define	_BROWSER_VP_DRAG_MODE		// Added by yoonjeong. 2007.01.05. VP Drag Mode  
//#	define	_BROWSER_THUMBNAIL_ON		// Core Platform Thumbnail 
//#	define _BROWSER_SAVEDPAGE_THUMBNAIL	// Saved Page Thumbnail 
//#	define _BROWSER_BOOKMARK_THUMBNAIL	// Bookmark Thumbnail 	

// Added by bkwoo. 2007.09.18		To support unsigned popup
#	define	_BROWSER_UNSIGNED_POPUP

// Added by bkwoo. 2007.04.18.   Redirect Confirm popup ֱ .
#	define	_BROWSER_DO_NOT_DISPLAY_REDIRECT_POPUP

#if defined ( _BROWSER_NETFRONT )
#	define _BROWSER_USE_EXTENDED_EBO_SETTING			// Access û EBO setting   ֵ.
#endif


// Added by nohsk. 2008.01.22: To support Continue Downloading.
#if !defined (_SHP_TERMINAL_CANDYBAR)
#	define	_BROWSER_CONTINUE_DOWNLOADING
#endif


#elif defined ( _SHP_OPERATOR_ORANGE ) || defined ( _SHP_OPERATOR_ORANGE_VANILLA )	// Added by nohsk. 2008.04.02 _SHP_OPERATOR_ORANGE_VANILLA ߰.
#	define	_BR_OPERATOR_ORANGE
#	undef	_BROWSER_HARDKEY_URL
#	define	_BROWSER_STATIC_APN		-1
#if defined( _BROWSER_NETFRONT )
#	define	_BROWSER_USE_REGISTRY_ZOOM
#endif // _BROWSER_NETFRONT

#elif defined ( _SHP_OPERATOR_TMOBILE )
#	define	_BR_OPERATOR_TMOBILE
#	undef	_BROWSER_HARDKEY_URL
#	define	_BROWSER_STATIC_APN		1    //bkseo:080825:tmo_asked:u900_u800
#	undef	_BR_INDICATOR_PERCENT_MODE	// Added by bkwoo. 2006.06.14  To support percent indicator //bkseo:080825:tmo_asked:u900_u800
#	define	_BROWSER_NOT_SUPPORT_LINGERTIME	// Added by bkwoo. 2006.10.17	To not support linger time.  //bkseo:080825:tmo_asked:u900_u800
#      define       _BROWSER_EXIT_CONFIRM    //bkseo:080825:tmo_asked:u900_u800
#	define	_BROWSER_DISABLED_LOGO_IMAGE
//#	define	_BROWSER_SPLASH_PAGE
#	define	_BROWSER_NOT_SUPPORT_SFRMODE
#	define	_BROWSER_CONFIRM_CONNECT_NETWORK      // WAP ӽ Ȯ˾
#	define	_BROWSER_DO_NOT_DISPLAY_REDIRECT_POPUP
#if defined ( _BROWSER_NETFRONT )
#	define	_BROWSER_USE_EXTENDED_EBO_SETTING
#endif
#	define	_BROWSER_COLUMN_RENDERING
//#  define   _BROWSER_KEEP_AUTH_INFO    //TMO PLû : [VQG] OMA FLٿε ID/PW 2 Էؾ ϴ .

#elif defined ( _SHP_OPERATOR_TMOUSA )
#	define	_BR_OPERATOR_TMOUSA
#	undef	_BROWSER_HARDKEY_URL
#	define	_BROWSER_STATIC_APN		1
#	define  _BROWSER_DISABLED_SETTING_MENU		// Added by jykorea. 2007.01.24  Setting menu Disabled
#	define	_BROWSER_SPLASH_PAGE
	
// Added by bkwoo. 2007.04.18.   ׻ Play  .
#	define	_BROWSER_ALLWAYS_QUERY_PLAY
#	define	_BROWSER_NOT_SUPPORT_SFRMODE
	
#elif defined (	_SHP_OPERATOR_H3G )
#	define	_BR_OPERATOR_H3G
#	undef	_BROWSER_HARDKEY_URL
#	define	_BROWSER_STATIC_APN		-1
#	define	_BROWSER_DISABLED_LOGO_IMAGE
#	define	_BROWSER_TEST_CACHE_DISABLE			// Advanced menu cache disableŰ ޴߰
#	if	(defined( _SHP_DRM_V2) || defined(_SHP_DRM_V21) )
#		define	_BROWSER_SUPPORT_CFM_DRM_V2		// _BR_OPERATOR_H3GUK  쿡 enable Ǿ 
#	endif

#elif defined ( _SHP_OPERATOR_TIM )
#	define	_BR_OPERATOR_TIM
#	undef	_BROWSER_HARDKEY_URL
#	define	_BROWSER_STATIC_APN		-1
#	define	_BROWSER_WHITE_UI				// Added by yoonjeong. 2007.02.05. White UI
#	define	_BROWSER_DISABLED_LOGO_IMAGE
#	if	(defined( _SHP_DRM_V2) || defined(_SHP_DRM_V21) )
#		define _BROWSER_SUPPORT_DRM2_SD		// Added by nohsk. 2008.04.11 To support DRM2 SD
#		define	_BROWSER_REMOVE_CHECKING_WINDOW
#	endif

#elif defined ( _SHP_OPERATOR_CINGULAR )
#	define	_BR_OPERATOR_CINGULAR
#	undef	_BROWSER_HARDKEY_URL
#	define	_BROWSER_STATIC_APN		-1
#	define	_BROWSER_REMEMBER_ENTERED_URL
#	define  _BROWSER_DOMAIN_PROXY_GW
#	define	_BROWSER_SUPPORT_CYCLE_FOCUS	// Added by bkwoo. 2006.08.08		To support cycle focus
// Splash image ñ ӽ÷ splash image disable ó
#	define	_BROWSER_DISABLED_LOGO_IMAGE	// Added by Leeky. 060915			To show Cingular logo
#	define	_BROWSER_SUPPORT_SIMPLE_TITLE	// Added by bkwoo. 2006.10.30.      To support simple title.
#	define	_BROWSER_NOT_SUPPORT_LINGERTIME	// Added by bkwoo. 2006.10.17		To not support linger time.
#	define	_BROWSER_UNSIGNED_POPUP			// Added by bkwoo. 2006.09.13		To support unsigned popup only for Cingular.
#	define	_BROWSER_SUPPROT_RINGTONE		// Added by yoonjeong. 2006.09.25.	To support 600K under size of ringtone save audio 
#	define	_BROWSER_DISPLAY_ISSUER			// Added by bkwoo. 2006.10.19.		To display issuer on information window.
#	define	_BROWSER_ONE_TOUCH

// OTA Music Concepts  (WMDRM)
//#	define 	_BROWSER_ATNT_MUSIC_OTA_CONCEPTS

// Added by bkwoo. 2007.04.18.   ׻ Play  .
#	define	_BROWSER_ALLWAYS_QUERY_PLAY

#elif defined (_SHP_OPERATOR_TELSTRA )		//Added by yoonjeong. 2006.05.25. TELSTRA
#	define	_BR_OPERATOR_TELSTRA
#	undef	_BROWSER_HARDKEY_URL
#	define	_BROWSER_STATIC_APN		-1
#	define	_BROWSER_WITHOUT_END_OF_HISTORY
#	define	_BROWSER_SPLASH_PAGE			// animated splash

#	define  _BROWSER_HSDPA_DOWNLOAD_THROUGHPUT_UP

// Added by chaehwan. 2007.05.17.   Redirect Confirm popup ֱ .
#	define	_BROWSER_DO_NOT_DISPLAY_REDIRECT_POPUP

#elif defined (_SHP_OPERATOR_TELEFONICA)	//Added by seungku.noh 2006.09.11. TELEFONICA
#	define	_BR_OPERATOR_TELEFONICA
#	undef	_BROWSER_HARDKEY_URL
#	define	_BROWSER_STATIC_APN		-1
#	define	_BROWSER_SUPPORT_STOP_DOWNLOADING
#	define	_BROWSER_CONFIRM_CONNECT_NETWORK    // WAP ӽ Ȯ˾

#elif defined ( _SHP_OPERATOR_ROGERS )
#	define	_BR_OPERATOR_ROGERS
#	undef	_BROWSER_HARDKEY_URL
#	define	_BROWSER_STATIC_APN		-1
#	define  _BROWSER_DOMAIN_PROXY_GW
//#	define	_BROWSER_SUPPORT_SIMPLE_TITLE	// Added by bkwoo. 2006.09.13.		To support simple title.
#	define	_BROWSER_UNSIGNED_POPUP			// Added by bkwoo. 2006.09.13		To support unsigned popup only for Cingular.
#	define	_BROWSER_NOT_SUPPORT_LINGERTIME	// Added by bkwoo. 2006.11.15		To not support linger time.

#elif defined (_SHP_SINGAPORE) || defined ( _SHP_OPERATOR_OPEN_SINGAPORE_MALAYSIA )				//Added by yoonjeong. 2006.12.15. For Singapore to support Preview. _SHP_SINGAPORE -> _SHP_OPERATOR_OPEN_SINGAPORE_MALAYSIA(Z240)
#	define	_BR_OPERATOR_SINGAPORE
#	undef	_BROWSER_HARDKEY_URL
#	define	_BROWSER_STATIC_APN		-1

#elif defined ( _SHP_OPERATOR_TAIWAN )				//Added by yoonjeong. 2007.01.24. For Taiwan to support RM, AVI, MIME check, before downloading.
#	define	_BR_OPERATOR_TAIWAN
#	undef	_BROWSER_HARDKEY_URL
#	define	_BROWSER_STATIC_APN		-1

#else // other operator
#	undef  _BROWSER_HARDKEY_URL
#	define	_BROWSER_STATIC_APN		-1
#endif

#if defined( _SHP_OPERATOR_OPEN_EUROPE_SLAV )
#	define _BROWSER_INPUT_LANGUAGE
#endif // SHP_OPERATOR_OPEN_EUROPE_SLAV


// Added by bkwoo. 2006.09.18		//  븸/߱ ⿡ On Ǿ .
#if defined(_SHP_COMMON_CHINA)
#define		_BROWSER_USE_IMEI_FOR_UA			// UserAgent IMEI ߰ϴ ..
#define		_BROWSER_IGNORE_MMF_TRANSFER		// MMFϿ  Permission Transfer  ˻  ʴ´.

	// added by bkwoo.  2006.10.09.    // ̸  븸⸸ Vendor̸ .
	#if defined(_SHP_INPUT_BOPOMOFO)		// Taiwan  ϱ  ӽ÷ .  
	#	define _BROWSER_IGNORE_VENDER_NAME
	#endif
	
	#if defined(_SHP_OPERATOR_HUTCHISON)
	#	define _BROWSER_OPERATOR_HONGKONG_H3G
	#endif

// 2007.01.09
#define		_BROWSER_IGNORE_NO_SERVICE_ERROR	//  䱸  No service area Network error ߻ ƹ  ޽ . 




#endif


/*============================================================================================
	LCD definition
==============================================================================================*/
#	undef	_BROWSER_MAINLCD_128X160
#	undef	_BROWSER_MAINLCD_176X220
#	undef	_BROWSER_MAINLCD_240X320
#	undef	_BROWSER_MAINLCD_240X400
#	undef	_BROWSER_MAINLCD_240X432

#if defined(_SHP_DEV_MAINLCD_240X432) 		// Q-Bowl (440x240)
#	define	_BROWSER_MAINLCD_240X432

#elif defined(_SHP_DEV_MAINLCD_240X400) 	// Theater (240x400)
#	define	_BROWSER_MAINLCD_240X400

#elif defined(_SHP_DEV_MAINLCD_240X320) 	// QVGA (240x320)
#	define	_BROWSER_MAINLCD_240X320

#elif defined(_SHP_DEV_MAINLCD_128X160)		// QQVGA (128x160)
#	define	_BROWSER_MAINLCD_128X160

#else // _BROWSER_MAINLCD_176X220			// QCIF (176x220)
#	define	_BROWSER_MAINLCD_176X220
#endif // _SHP_DEV_MAINLCD_240X320



/*----------------------------------------------------------------------------------------
	[ Bitmap information ] 20070116 by einus

 1. QVGA ( 240 x 320 )
	- Splash image ( 226 x 223 ) [indicator main	( 240 x 237 )]
	- Access logo  ( 240 x 144 ) [title main		( 240 x 216 )]

 2. QCIF ( 176 x 240 )
	- Splash image ( 162 x 165 ) [indicator main	( 176 x 165 )]
	- Access logo  ( 176 x 150 ) [title main		( 176 x 150 )]

 2. QQVGA ( 128 x 160 )
	- Splash image ( 114 x 115 ) [indicator main	( 128 x 115 )]
	- Access logo  ( 128 x 108 ) [title main		( 128 x 108 )]

  cf. 1. the max width of splash image = screen width - ( 2 x the width of scroll bar[7px] )
      2. QVGAε Access logo image width[144] ۾Ҵ ? 
		=> UI  쵵  image ϱ ؼ..
		(UI, UI image  ϵ    .)
-------------------------------------------------------------------------------------------*/




/*============================================================================================
	Font size
==============================================================================================*/
// _BROWSER_DEFAULT_FONT_SIZE :  ϴ default font size
// _BROWSER_DEFAULT_FONT_INCREASE_SIZE = ( _BROWSER_DEFAULT_FONT_SIZE - Access  ûϴ font size )
// waveFindFontPeer .
#if defined ( _SHP_DEV_MAINLCD_240X432 )
#	define		_BROWSER_DEFAULT_FONT_SIZE				18
#	define		_BROWSER_DEFAULT_FONT_INCREASE_SIZE		0
#	define		_BROWSER_DEFAULT_FONT_IME_DECREASE		0

#elif defined ( _SHP_DEV_MAINLCD_240X400 )
#	define		_BROWSER_DEFAULT_FONT_SIZE				18
#	define		_BROWSER_DEFAULT_FONT_INCREASE_SIZE		0
#	define		_BROWSER_DEFAULT_FONT_IME_DECREASE		0

#elif defined ( _BROWSER_MAINLCD_240X320 )
#	define		_BROWSER_DEFAULT_FONT_SIZE				18
#	define		_BROWSER_DEFAULT_FONT_INCREASE_SIZE		0
#	define		_BROWSER_DEFAULT_FONT_IME_DECREASE		0

#elif defined ( _BROWSER_MAINLCD_176X220 )
#	define		_BROWSER_DEFAULT_FONT_SIZE				16
#	define		_BROWSER_DEFAULT_FONT_INCREASE_SIZE		0
#	define		_BROWSER_DEFAULT_FONT_IME_DECREASE		0

#else // if defined ( _SHP_DEV_MAINLCD_128X160 )
#	define		_BROWSER_DEFAULT_FONT_SIZE				14
#	define		_BROWSER_DEFAULT_FONT_INCREASE_SIZE		0
#	define		_BROWSER_DEFAULT_FONT_IME_DECREASE		0

#endif



//  UI ʴ 𵨿 忡  찡 ־ Ƶ
// Q-Bowl   ٽ . rtaewoo, 070508
#if defined(_SHP_UI_HORIZONTAL)
#	define _BROWSER_UI_HORIZONTAL		//  UI 
#endif // _SHP_UI_HORIZONTAL



// Bookmark, EnterURL  EditField Է  ִ Max length
#define		_BROWSER_MAX_STRING							1024
#define		_BROWSER_MAX_URL							_BROWSER_MAX_STRING
#define		_BROWSER_MAX_TITLE							_BROWSER_MAX_STRING
#define		_BROWSER_MAX_SEARCH_STRING					(_BROWSER_MAX_STRING / 4)

// vertical scroll bar width in the contents
#define		_BROWSER_VERTICAL_SCROLL_WIDTH				7





/*============================================================================================
	Model settings and features
=============================================================================================*/


// Flash support ( only Hutchison and NfBrowser )
// Flash support - unicon ߿ ߰ by rtaewoo, 070419
// Telstra  Flash   by rtaewoo, 070530
#ifndef _SHP_OPERATOR_TELSTRA
#	define	_BROWSER_HUTCHISON_NF_FLASH	// temp chaehwan 2006.03.03
#endif


// Added by bkwoo. 2006.11.15	
//  𵨿 ؼ Linger Time  .    Define     ڵ Define.
#if defined ( _SHP_CONCEPT_AMERICA )
#define _BROWSER_NOT_SUPPORT_LINGERTIME
#endif

#if defined ( _BROWSER_OPERA )
#define	OPERA_SAMSUNG_BUILD	// samsung side build support. inhyuk.baek
//#define _BROWSER_NOT_SUPPORT_LINGERTIME
#endif

// bs0425.lee  Jasmine Browser not support LingerTime.
#if defined ( _BROWSER_JASMINE )
#define _BROWSER_MULTITAB
#define _BROWSER_JSOPENWINDOW_NOMULTITAB_UI
#define JS_MULTIPLE_WINDOW_SUPPORT /* Anjana - UI changes for JS New Window */
#define _BROWSER_NOT_SUPPORT_LINGERTIME
//#define SFB_DRAG_DROP
//#define	_BROWSER_ENABLE_PAGE_PILOT	// PagePilot  
#define _BR_DOWNLOAD_UI
#define SFB_UPDATE_URL_BAR

#define _JASMINE_PLANE_SCROLL   //  Second scroll .  
#define _SFB_FLICK_SCROLL  //  flick scroll. 
//#define _SFB_TOUCH_SCROLLBAR  //  Touch scroll bar feature. 
//#define SFB_IVIEW_IMAGE		/* iView Jasmine Browser Diff. feature */
#define SFB_IMPROVE_END_KEY		/* To Improve end Key performance */

//#define SFB_PREF_SETTINGS  /* for pageoverview and plugin in preferences*/

#	if defined	_BROWSER_ENABLE_PAGE_PILOT
		#define _SFB_PAGE_PREVIEW
#	endif
#if !defined (_SFB_SEARCH_STRING_IN_PAGE)
#       define _SFB_SEARCH_STRING_IN_PAGE
#endif

//#if !defined (SFB_SMARTLINK_FEATURE)
//#       define SFB_SMARTLINK_FEATURE
//#endif

#endif

// for Z170 Orange : added by smart.yj.kim 2007-03-29
#if defined( _SHP_SETTING_Z170 ) || defined(_SHP_SETTING_Z240)
#	if	defined( _SHP_OPERATOR_ORANGE )
#		define _BROWSER_WHITE_UI
#	endif
#endif


// Support Touch Screen
#if defined ( _SHP_DEV_TOUCH_SCREEN )
	#define	_BROWSER_SUPPORT_TOUCH
#endif

#if defined ( _SHP_GWES_EFFECT_SLIDE_HORIZONTAL )
	#define _BROWSER_SUPPORT_EFFECT_SLIDE_HORIZONTAL
#endif

/*********************************************************************************************************************/
/*********************************************************************************************************************/

//#if defined ( _BROWSER_UNICON )

#define	_BROWSER_GWES_FLASH
#define	_BROWSER_SWIFT_NAVI
#define	_BROWSER_VIRTUAL_POINTER
#define	_BROWSER_ENABLE_PAGE_PILOT
#define	_BROWSER_HOT_LONGKEY

#if defined ( _BROWSER_HOT_LONGKEY )
	//#	define	_BROWSER_SEARCH_ON_SITE
	#define	_BROWSER_FULL_SCREEN
	#define	_BROWSER_AUTO_RUN_JAVA			// Added by yoonjeong. 2006.12.21. AUTO RUN  Java launch ϰ  
#endif

#if !defined ( _BROWSER_MAINLCD_128X160 )
	#define	_BROWSER_SUPPORT_VECTOR_FONT
#endif

#if defined ( _BROWSER_SUPPORT_VECTOR_FONT )
	#define	_BROWSER_FONT_MAX_ID_PER_SET		100
	#define	_BROWSER_PSEUDOFONT			_BROWSER_DEFAULT_FONT_SIZE
	//#	define	_BROWSER_DEMO_ZOOM_INOUT	//	NF 3.3 Zoom Inout
	#define	_BROWSER_ZOOM_INOUT		//	Added by insoo.lee	2007.02.14.	NF 3.4 Zoom Inout
#endif // _BROWSER_SUPPORT_VECTOR_FONT

#if !defined (_BROWSER_WHITE_UI)			// Changed by yoonjeong. 2007.03.16.
	#define _BROWSER_BLACK_UI			//Added by seungku.noh  2006.08.30
#endif

//#endif		// _BROWSER_UNICON

/*********************************************************************************************************************/

// Modified by my.ban 2008.04.02
// _BROWSER_MODEL_QBOWL => _BROWSER_SUPPORT_TOUCH
#if defined ( _BROWSER_SUPPORT_TOUCH )

	#define _BROWSER_NTOUCH_UI						// 2008.04.07 Added by my.ban
	#define	_BROWSER_FLOATING_MENU
	#define	_BROWSER_ENABLE_TOOLBOX
#if defined(_BR_OPERATOR_TMOBILE) || defined(_BR_OPERATOR_ORANGE)
   #define _BROWSER_ENABLE_MORE_MENU
#endif   

#	if defined ( _BROWSER_NTOUCH_UI )
		#undef	_BROWSER_FLOATING_MENU
		#undef	_BROWSER_ENABLE_TOOLBOX
		#undef	_BROWSER_SUPPORT_SIMPLE_TITLE
		#undef	_BROWSER_REMEMBER_ENTERED_URL

		#	define	_BROWSER_MOVE_REVERSE				// Added by KTChoi for Vodafone requirement of moving reversly. 
		#define	_BROWSER_FEATURE_LAST_VIEWED_PAGE
		#define	_BROWSER_FLOATING_SAVE_IMAGE_MENU	// Added by inhyuk.baek for image saved, print, via message.
	//	#define _BROWSER_PLANE_SCROLL	// added by chaehwan 2008.09.07
#	endif

	//#	define	_BROWSER_DYNAMIC_VISUAL_BOOKMARK	// Added by KTChoi for dynamic update of visual bookmark 2007.07.18
	#define	_BROWSER_DBCLICK_NOTI_EVENT				// chaehwan : 2007.06.06 double click ÿ ߻ϴ select noti  óϱ  define ( only QBOWL )

	//#	dfine	_BROWSER_ENABLE_PAGE_PILOT
	#define _BROWSER_HSDPA_DOWNLOAD_THROUGHPUT_UP	// Added by bkwoo. 2007.08.01

	// chaehwan 20070831 Vodafone CUSTOM
	// chaehwan 20070823 browser view mode ( smartfit <-> desktop ) ȯ ޴ disable
	#undef	_BROWSER_DISABLE_PAGE_VIEWMODE
	//#define	_BROWSER_SETTING_USING_NV			// einus 20070911 : screen, rendering mode NV 

	#define	_BROWSER_IMPROVE_TOUCH_BY_ACCESS		// 20071227 einus touch performance ڵ 

	#define	_BROWSER_SUPPORT_JAVA_CATEGORY			// Added by yoonjeong. 2008.301.24.	ġ 𵨿  Java file  ΰ Media Ʒ  ʾ, Java Category KJX   .

#	if defined ( _BROWSER_VIRTUAL_POINTER )
		#undef _BROWSER_VIRTUAL_POINTER
#	endif

#	if defined ( _BROWSER_NOT_SUPPORT_SFRMODE )		// chaehwan 20070831 Vodafone CUSTOM
		#undef _BROWSER_NOT_SUPPORT_SFRMODE
#	endif

#endif		// _BROWSER_SUPPORT_TOUCH

/*********************************************************************************************************************/
/*********************************************************************************************************************/


//#if defined ( _BR_OPERATOR_VODAFONE ) && !defined (_SHP_TERMINAL_SLIDER) && !defined (_SHP_TERMINAL_CANDYBAR)
//#	define	_BROWSER_CONTINUE_DOWNLOADING     // Added by yoonjeong. 2007.01.25. Downloading Sub LCD .
//#endif


// for G400 Protean. Added by nohsk. 2007.11.29
#if defined ( _SHP_SETTING_G400 ) 
#	define _BROWSER_HSDPA_DOWNLOAD_THROUGHPUT_UP
#endif

// Added by sumdra. 2008.02. 18
#if ( defined ( _SHP_OPERATOR_VODAFONE ) && ( defined ( _SHP_SETTING_L770 ) || defined ( _SHP_SETTING_U900 ) ))
#	define _BROWSER_HSDPA_DOWNLOAD_THROUGHPUT_UP
#endif

#if defined ( _SHP_SETTING_P960 ) 
#	define _BROWSER_HSDPA_DOWNLOAD_THROUGHPUT_UP
#endif

// Added by yongha. 2007.07.14.   Redirect Confirm popup ֱ .
#	define	_BROWSER_DO_NOT_DISPLAY_REDIRECT_POPUP

// test by yj.kim for CHAPI
#if defined( _SHP_SETTING_DOLBY )
#	define _BROWSER_UNSIGNED_POPUP
#endif
/*============================================================================================
	SHP define  features
=============================================================================================*/

#if defined ( _SHP_CONCEPT_AMERICA )
#	define _BROWSER_CONCEPT_AMERICA
#endif

// Device type
#if defined ( _SHP_TERMINAL_SLIDER )
#	define	_BROWSER_TERMINAL_SLIDER
#endif // _SHP_TERMINAL_SLIDER

#if defined ( _SHP_DEV_KEY_QWERTY )
#	define	_BROWSER_SUPPORT_QWERTY_ENTER_KEY
#endif	// _SHP_DEV_KEY_QWERTY

#if defined ( _SHP_UI_TOUCH_SOFTKEY_2MENU )
#	define _BROWSER_BG_BITMAP_FG_TEXT_SOFTKEY	// background bitmap̰, foreground text  (touch screen)
#endif // _SHP_UI_TOUCH_SOFTKEY_2MENU

// Support No SIM Mode
#if defined ( _SHP_NO_SIM_MODE )
#	define	_BROWSER_SUPPORT_NOSIM
#endif // _SHP_NO_SIM_MODE

// definiton for ZV60. added by younim. 061124
#if	(defined( _SHP_DRM_V2) || defined(_SHP_DRM_V21) )
#	define	_BROWSER_DRM2
#	define  _BROWSER_CAN_SAVE_EXTERNAL_MEMORY
#endif

// DRM		// Added by bkwoo. 2006.07.28
#if defined (_SHP_DRM_FL_ONLY) || defined (_SHP_NO_DRM)
#	define _BROWSER_NOT_SUPPORT_DRM
#endif

#if defined ( _SHP_FLASH_INTERACTION )
#	define	_BROWSER_FLASH_UI
#endif

#if defined ( _SHP_TIME_1900_BASE )
#	define _BROWSER_TIME_1900_BASE
#endif //  _SHP_TIME_1900_BASE


// File Viewer  η SVG, SWF, DOC, PPT, EXCEL, PDF, TXT  ´.
// _SHP_FILE_VIEWER   by rtaewoo, 070420
//#if defined ( _SHP_FILE_VIEWER )
#	define	_BROWSER_FILE_VIEWER	// Added by bkwoo.  2006.06.30
//#else
//  File viewer ٸ Flash   ʰ Ѵ.
//#	if defined(_BROWSER_HUTCHISON_NF_FLASH)
//#		undef	_BROWSER_HUTCHISON_NF_FLASH
//#	endif
//#endif

// Image Viewer MX    ImageViewer ҷش.
#if defined ( _SHP_IMAGEVIEWER )
#	define _BROWSER_IMAGE_VIEWER	// Added by yoonjeong. 2007.08.02.
#endif

// C Key is BACK
#if defined ( _SHP_KEY_C_IS_BACK )
#	define	_BROWSER_ENABLED_CLEAR_BACK_KEY
#endif

// Right softkey is for Back/Clear on EditField, EditArea
// ( When focused editor field has some data, RSK acts as the clear key. )
#if defined ( _SHP_KEY_COMMON_C_RSK )
#	define	_BROWSER_RSK_EDIT_CONCEPT
#endif

// T-Mobile EditField, EditArea concept
// Right softkey is for changing input mode
#if defined ( _SHP_DEV_TMOUSA_INPUT )
#	define	_BROWSER_TMOUSA_EDIT_CONCEPT
#endif

// Not support E-Mail
#if defined ( _SHP_EMAIL_NONE )
#	define	_BROWSER_NOT_SUPPORT_EMAIL
#endif

// to support Z400H3G
#if defined ( _SHP_PROTO_ALWAYS_ON )
#	define _BROWSER_PROTO_ALWAYS_ON
#endif

// to support Real Media      // Added by yoonjeong. 2007.01.24.
#if defined ( _SHP_REAL_PLAYER )
#	define _BROWSER_REAL_PLAYER 
#endif

// to support Progressive Download Support	// Added by yoonjeong. 2007.03.09.
// OMA DD - Progressive Download Support.    - DD <ProgressiveDownloadFlag>  True ̸ Browser ƴ MP ٿε Ѵ.
#if defined ( _SHP_DRM_PD )
#	define _BROWSER_SUPPORT_PROGRESSIVE_DOWNLOAD	
#endif

// WMDRM 
//#if defined(_SHP_DRM_WMDRM_CAMESE)
//#	define	_BROWSER_SUPPORT_WMDRM_CAMESE
//#	define  _BROWSER_SUPPORT_SHPHTTP_STACK_FOR_ALBUM_ART
//#endif

#if defined ( _SHP_MY5 )
#	define  _BROWSER_SUPPORT_MY5				// Added by yoonjeong. 2007.06.18. To support MY5
#endif

// to support Changeable GUI	Added by nohsk. 2007.11.29
#if defined (_SHP_GUI_CHANGEABLE)
#	define	_BROWSER_GUI_CHANGEABLE
#endif

// Added by yoonjeong. 2007.12.06.	DVB-H  Right Object 
#if defined ( _SHP_DVB_BCAST )
#	define _BROWSER_MODEL_BCAST
#endif 

#if defined ( _SHP_PROGRESSIVE_DOWNLOAD )
# define _BROWSER_PROGRESSIVE_DOWNLOAD
#endif


// for WMDRM
// added by jaeik.lee  at&t Music OTA Concept ߿  ߰ǰų  .

// added by jaeik.lee  at&t Music OTA Concept ߿  ߰ǰų  .
#if defined (_BROWSER_ATNT_MUSIC_OTA_CONCEPTS)
	#undef	_BROWSER_ALLWAYS_DO_NOT_QUERY_PLAY 

	#if defined(_SHP_DOWNLOAD_STATUS)
	#	define	_BROWSER_SUPPORT_DOWNLOAD_DB
	#endif

	// Added by jaeik. 2007.07.06 //tyramis:070928:ATandT ٽ ش޶ û..
//	# 	define	_BROWSER_SUPPORT_CANCEL_QUERY_FOR_GETTING_LICENSE
 // miranss_070921 :   background download is not supported
//	#	define	_BROWSER_SUPPORT_BACKGROUND_DOWNLOAD 
	#	define 	_BROWSER_SUPPORT_RETRY_ON_FAILED_DIALOG

#endif // #if defined (_BROWSER_ATNT_MUSIC_UI_CONCEPTS)

#if defined ( _SHP_DEV_DACP_128X112 )
#	define	_BROWSER_SUPPORT_DACP
#endif

// Add by nohsk. 2008.06.24. MM Re-engineering API : #ifndef _SHP_MM_LEGACY
#if defined (_SHP_MM_LEGACY)
#	define	_BROWSER_MM_LEGACY
#endif


#if defined (_SHP_MY_BLOG)
#	define _BROWSER_USE_MY_BLOG
#endif
/*============================================================================================
	Browser ü features
=============================================================================================*/

// Transparent ϱ  library  ߰ ʿ ڵ, Q-bowl 
#define	_BROWSER_ACCESS_WAVE_SUPPORT_TRANSPARENT


#define _BROWSER_DOWNLOAD_JAVA_WITHOUT_MSG

// To support extended browser setting.
#define _BROWSER_USE_EXTENDED_SETTING				// Added by bkwoo. 2006.07.27

// For supporting IMSA (iMusic store application),  
//#define	_BROWSER_IMSA

// for test MTHML viewer chaehwan ( only ACCESS )
//#define	_BROWSER_MHTML_VIEWER


// Task  ̱ .
#define _BROWSER_TRY_TO_REDUCE_TASK		


// Virtual pointer õǼ pointer ó GC ϵ 
#define _BROWSER_TRY_TO_IMPROVE_SCREEN_PERFORM	// Added by bkwoo. 2007.02.16

#if ( defined ( _BROWSER_MAINLCD_240X320 ) && defined ( _BROWSER_CONCEPT_AMERICA ) )
#	define _BROWSER_MANU_LIST_SHOW_SUB_ICON
#endif

// JAVA MVM   define
#define _BROWSER_LAUNCH_JAVA_MVM

// text search 
#if defined ( _BROWSER_OPERA )
//#	define	_BROWSER_SEARCH_ON_TEXT
#endif // _BROWSER_OPERA

// Download: Issuer display
#ifndef _BROWSER_DISPLAY_ISSUER
#	define	_BROWSER_DISPLAY_ISSUER
#endif

// Download: ׻ Play  
#ifndef _BROWSER_ALLWAYS_QUERY_PLAY
#	define	_BROWSER_ALLWAYS_QUERY_PLAY
#endif

// Netscape Gecko based video plugin support
//#define	_BROWSER_SUPPORT_NP_VIDEOPLUGIN

// Flash Enable/Disable
#define	_BROWSER_FLASH_ENABLE



// Invisible Image request Enable/Disable
//#define	_BROWSER_INVISIBLE_IMAGE_REQUEST

/*============================================================================================
	Simulator     features
=============================================================================================*/
#if defined ( _BROWSER_SIMUL )

#if defined (_BROWSER_NETFRONT)
//#define _BROWSER_SUPPORT_MULTIPLE_DOWNLOAD
#endif
/*
#	if !defined(_BR_INDICATOR_PERCENT_MODE)		// Simul , Percent Indicator enableŴ
#		define _BR_INDICATOR_PERCENT_MODE
#	endif
*/

#	ifndef _BROWSER_BLACK_UI
#		define _BROWSER_BLACK_UI
#	endif


//#	define _BROWSER_WHITE_UI



// Cancel or EndŰ  Downloading ߰ ڿ ࿩ .
#	ifndef _BROWSER_SUPPORT_STOP_DOWNLOADING
#		define _BROWSER_SUPPORT_STOP_DOWNLOADING// Added by bkwoo. 2006.10.16.   
#	endif

#	ifndef _BROWSER_FILE_VIEWER
#		define _BROWSER_FILE_VIEWER
#       endif
// To support small title window to display title.
//#	ifndef _BROWSER_SUPPORT_SIMPLE_TITLE
//#		define _BROWSER_SUPPORT_SIMPLE_TITLE	// Added by bkwoo. 2006.10.25	
//#	endif

#	define	_BR_CORE_CONFIG_DEBUG			// Added by bkwoo. 2006.08.22

#	ifndef _BROWSER_SUPPORT_DEFAULT_DOWNLOAD_STORAGE
//#		define _BROWSER_SUPPORT_DEFAULT_DOWNLOAD_STORAGE	// Vodafone  Phone setting Default  Storage  Ѵ.  2007.01.18
#	endif


// wmdrm  ׽Ʈ ùķ.. lic , Content lic  ׽Ʈ ƹ̳ ޴´. 
#	ifndef _BROWSER_SUPPORT_WMDRM_CAMESE
//#define _BROWSER_SUPPORT_WMDRM_CAMESE
//#define _BROWSER_SUPPORT_WMDRM_CAMESE_SIMUL
//#define _BROWSER_SUPPORT_SHPHTTP_STACK_FOR_ALBUM_ART
#	endif

// Added by bkwoo. 2007.04.18.   ׻ Play  .
//#	define _BROWSER_ALLWAYS_QUERY_PLAY

#endif 	// #if defined ( _BROWSER_SIMUL )
//===========================================================================================

//#define		_BROWSER_SUPPORT_STORAGE_SELECTION_POPUP	// 2008.09.30 yj.kim storage popup  ü 𵨿  .   ܵ

#ifdef _SHP_RSS_READER				// Added by bkwoo. 2007.05.09
#define _BROWSER_USE_RSS_READER		// Rss mime   Rss Reader .
#endif

// Added by bkwoo. 2007.08.01
#if defined(_BROWSER_HSDPA_DOWNLOAD_THROUGHPUT_UP)

#define _BROWSER_USE_SOCKET_POLLING						// Socket polling  .
#define _BROWSER_SUPPORT_SIMPLE_DOWNLOAD_WINDOW			// UI & GUI ȭ

//#define	_BROWSER_HSDPA_DISPLAY_INFO_TEST				// Performance   ϱ .

#endif




#ifdef _BROWSER_USE_EXTENDED_EBO_SETTING
#	define	_BR_CORE_CONFIG_DEBUG			// Added by bkwoo. 2007.09.15.   EBO Link Error  .
#endif

// #define	_BR_HISTORY_SUPPORT_VBM				// Added by miju.kim 2007.11.27		History / History details  send/copy url menu ߰

/*============================================================================================
	Constant define
=============================================================================================*/

#if defined ( _BROWSER_SUPPORT_TOUCH )
#	define BR_CORE_HEAP_SIZE_MAX					(4 * 1024 * 1024)		// 4Mb. // for performance
#else
#	define BR_CORE_HEAP_SIZE_MAX					(2 * 1024 * 1024)		// 2Mb.
#endif	// _BROWSER_SUPPORT_TOUCH




#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _BR_CONFIG_H_
