/**
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */

/**
 *  This file is the main header which encapsulates the following components
 *		1. UrlLoader
 *		2. SFBal
 *		3. Request Mgr
 *		4. Cookie & Cache
 *		5. Authentication
 *		6. Plugin
 *
 *	It is kept in ShpBrowser/H because, all the above can be used by other external applications.
 *
 * @name        ShpJasmine.h
 * @author      Pushparajan Vijayakumar ( rajan.vp@samsung.com )
 */

#ifndef _SHP_JASMINE_H
#define _SHP_JASMINE_H


//#include "Shp.h"

//BAL
#include "SFBalMain.h"

//Request Mgr
#include "SFBRmMgr.h"
#include "SFBRmCore.h"

// Utilities
#include "SFBCookie.h"
#include "SFBCache.h"
#include "SFBAuth.h" 

#if defined(__cplusplus) // below headers not available for C files
// UrlLoader

#include "IURI.h"
#include "ILoadGroup.h"

//Plugin
#include "NPGluePluginDLL.h"

#endif

#include "UrlLoaderECOM.h"

#endif // _SHP_JASMINE_H
