/*
 * Samsung Mobile Browser
 * Copyright (c) 2007 SISO
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */

/** 
 * This file contains Auto Form Fill requirement
 *
 * @author          Pramod  pramod.bs@samsung.com
 */

/* Version History
Author		Date		BugID		BugDescription

*/

#ifndef _SFBAL_FORM_STORAGE_H_
#define _SFBAL_FORM_STORAGE_H_
 
#define SFB_AUTOFORM_FILL_FILE_NAME			"/User/Br/SFB/FF.dat"	/*Auto form fill file name */
#define SFB_AUTOFORM_FILL_BACKUP_NAME			"backUp.dat"

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

typedef void (*AddEntryToPageMap)( char*, char*, char* );

/**
 * This function saves Auto Form Fill data to persistent.
 * 
 * @return		TRUE if succeeded or FALSE
 */
BOOL SFBalFSWriteAutoFormFill(char* szUrl,char* szForm, char*	NameValuePair );


/**
 * This function read Auto Form Fill from persistent.
 * 
 * @param		None
 * @return		TRUE
 */
BOOL SFBalFSReadAutoFormFill(AddEntryToPageMap constructEntry);

void SFBalFSDeleteAutoFormFill( void );


#ifdef __cplusplus
}
#endif // __cplusplus

#endif //_SFBAL_FORM_STORAGE_H_