/*
* ==============================================================================
*  Name        : BrowserControl_Iterator.hpp
*  Part of     : Browser Control.
*  Description : Defines a default iterator interface.
*  Version     :
*
*    Copyright (c) 2007,
*    All rights reserved.
* ==============================================================================
*/
#ifndef __BROWSERCONTROL_ITERATOR_HPP__
#define __BROWSERCONTROL_ITERATOR_HPP__

#include "BrowserControl_DataTypes.h"
#include "CMMDefs.h"

/**
 * @defgroup Iterator Iterator API
 */


class BrowserControl_Iterator CMM_MODIFIED
{
public:

	virtual ESTATUS BrowserControl_Iterator_First(gpointer aItem, gulong* aSize) = 0;
	virtual ESTATUS BrowserControl_Iterator_End(gpointer aItem, gulong* aSize) = 0;
	virtual ESTATUS BrowserControl_Iterator_Next(gpointer aItem, gulong* aSize) = 0;
	virtual ESTATUS BrowserControl_Iterator_Previous(gpointer aItem, gulong* aSize) = 0;
	virtual ESTATUS BrowserControl_Iterator_SkipNext() = 0;
	virtual ESTATUS BrowserControl_Iterator_SkipPrevious() = 0;
};
#endif //__BROWSERCONTROL_ITERATOR_HPP__

