/*
* ==============================================================================
*  Name        : BrowserControl_History.hpp
*  Part of     : Browser Control.
*  Description : Implements browser control history.
*  Version     :
*
*    Copyright (c) 2007,
*    All rights reserved.
* ==============================================================================
*/

#ifndef __BROWSERCONTROL_HISTORY_HPP__
#define __BROWSERCONTROL_HISTORY_HPP__

#include "BrowserControl_DataTypes.h"
#include "BrowserControl_Iterator.hpp"  

/**
 * @defgroup History History related APIs
 */

//------------------------------------------------------------------------
// History API:
//------------------------------------------------------------------------

class BrowserControl_History : public BrowserControl_Iterator
{
public:

	ESTATUS BrowserControl_GetHistoryIteratorHandle(HANDLE* aHistoryIteratorHandle);
	ESTATUS BrowserControl_GetHistoryCount(guint* aCount);
	ESTATUS BrowserControl_ClearHistory();
	ESTATUS BrowserControl_SetMaxHistoryCount(const guint aCount);
	ESTATUS	BrowserControl_ClearForwardHistory();
	ESTATUS	BrowserControl_ClearBackwardHistory();
	ESTATUS	BrowserControl_DeleteHistoryItem(const guint aIndex);

	// Iterator implementation
	ESTATUS BrowserControl_Iterator_First(gpointer aItem, gulong* aSize);
	ESTATUS BrowserControl_Iterator_End(gpointer aItem, gulong* aSize);
	ESTATUS BrowserControl_Iterator_Next(gpointer aItem, gulong* aSize);
	ESTATUS BrowserControl_Iterator_Previous(gpointer aItem, gulong* aSize);
	ESTATUS BrowserControl_Iterator_SkipNext();
	ESTATUS BrowserControl_Iterator_SkipPrevious();
};
#endif //__BROWSERCONTROL_HISTORY_HPP__

