#ifndef __TYPES_H__
#define __TYPES_H__


/**
 * Basic Data Types.
 * Fundamental data type definitions.
 * @ingroup BasicDataTypes
 */
typedef char				gchar; 
typedef short				gshort; 
typedef long				glong; 
typedef int					gint; 
typedef gint				gboolean;
typedef gboolean			gbool;
typedef unsigned char		guchar; 
typedef unsigned short		gushort; 
typedef unsigned long		gulong; 
typedef unsigned int		guint; 
typedef float				gfloat; 
typedef double				gdouble;
typedef void*				gpointer;
typedef int					HWIN;
#ifndef BOOL
typedef int					BOOL;
#endif
/**
 * ProgressHandler.
 * Callback signature for progress handler.
 * @ingroup Observer
 */
typedef void (*ProgressHandler)(guint, long long ,HWIN,int);

/**
 * TitleChangedHandler.
 * Callback signature for title changed handler.
 * @ingroup Observer
 */
typedef void (*TitleChangedHandler) (const char*, const char*);

/**
 * LinkHoveringHandler.
 * Callback signature for link hovering event handler.
 * @ingroup Observer
 */
typedef	void (*LinkHoveringHandler) (void);

/**
 * StatusbarTextChangedHandler.
 * Callback signature for statusbar text changed handler.
 * @ingroup Observer
 */
typedef	void (*StatusbarTextChangedHandler) (const char*);

/**
 * IconLoadedHandler.
 * Callback signature for Icon Loaded handler.
 * @ingroup Observer
 */
typedef	void (*IconLoadedHandler) (void);

/**
 * SelectionChangedHandler.
 * Callback signature for Selection Changed handler.
 * @ingroup Observer
 */
typedef	void (*SelectionChangedHandler) (void);
typedef void (*UrlSchemeHandler)(const char*);
typedef void (*UIStateHandler)(const char*,int,HWIN);



#endif /*__TYPES_H__*/