/*
* ==============================================================================
*  Name        : BrowserControl_Iterator_Interface.h
*  Part of     : Browser Control.
*  Description : Defines a default iterator interface.
*  Version     :
*
*    Copyright (c) 2007,
*    All rights reserved.
* ==============================================================================
*/

#include "BrowserControl_Iterator_Interface.h"
#include "BrowserControl_Iterator.hpp"
/**
 * @defgroup Iterator Iterator API
 */

extern "C"
{

ESTATUS BrowserControl_Iterator_First(HANDLE aIteratorHandle, gpointer aItem, gulong* aSize)
{
	return ((BrowserControl_Iterator*)aIteratorHandle)->BrowserControl_Iterator_First(aItem, aSize);
}

ESTATUS BrowserControl_Iterator_End(HANDLE aIteratorHandle, gpointer aItem, gulong* aSize)
{
	return ((BrowserControl_Iterator*)aIteratorHandle)->BrowserControl_Iterator_End(aItem, aSize);
}

ESTATUS BrowserControl_Iterator_Next(HANDLE aIteratorHandle, gpointer aItem, gulong* aSize)
{
	return ((BrowserControl_Iterator*)aIteratorHandle)->BrowserControl_Iterator_Next(aItem, aSize);
}

ESTATUS BrowserControl_Iterator_Previous(HANDLE aIteratorHandle, gpointer aItem, gulong* aSize)
{
	return ((BrowserControl_Iterator*)aIteratorHandle)->BrowserControl_Iterator_Previous(aItem, aSize);
}

ESTATUS BrowserControl_Iterator_SkipNext(HANDLE aIteratorHandle)
{
	return ((BrowserControl_Iterator*)aIteratorHandle)->BrowserControl_Iterator_SkipNext();
}

ESTATUS BrowserControl_Iterator_SkipPrevious(HANDLE aIteratorHandle)
{
	return ((BrowserControl_Iterator*)aIteratorHandle)->BrowserControl_Iterator_SkipPrevious();
}

} //extern "C"
