#ifdef SFB_WIDGET
#ifndef WIDGET_OBJECT_H_
#define WIDGET_OBJECT_H_

#include "widget_instance.h"
#include "function_object.h"
#include "lookup.h"
#include "DOMWindow.h"
#include "KURL.h"
#include "ResourceRequest.h"
#include "Frame.h"
#include "FrameLoader.h"
#include "Page.h"
#include "ChromeClient.h"


namespace WebCore {
	class Frame;
	class FrameLoader;
	class DOMWindow;
	class Loader;
	class KURL;
	class ResourceRequest;
	class Page;
	class ChromeClient;
}
namespace KJS {

	class Window;
	class JSXMLHttpRequest;

	class WidgetPrototype : public WidgetInstance  
	{
	  public:

		WidgetPrototype(ExecState*, ObjectPrototype*);
		bool getOwnPropertySlot(ExecState*, const Identifier&, PropertySlot&);
		void getPropertyNames(ExecState* , PropertyNameArray& );
		virtual const ClassInfo* classInfo() const { return &info; }
		static const ClassInfo info;

	};

    class WidgetObjectImp : public InternalFunctionImp
    {
	  public:
		WidgetObjectImp(ExecState*, FunctionPrototype*, WidgetPrototype*);

		virtual bool implementsConstruct() const;
		virtual JSObject* construct(ExecState*, const List&);
		virtual JSValue* callAsFunction(ExecState*, JSObject*, const List&);
	};

  JSValue* widgetProtoFuncsetPreferenceKey(ExecState* exec, JSObject* thisObj, const List&);
  JSValue* widgetProtoFuncMaximiseWindow(ExecState* exec, JSObject* thisObj, const List&);
  JSValue* widgetProtoFunPreferenceForKey(ExecState* exec, JSObject* thisObj, const List& args);
  JSValue* widgetProtoFuncOpenUrl(ExecState* exec, JSObject* thisObj, const List& args);
  JSValue* widgetProtoFuncGetLanguage(ExecState* exec, JSObject* thisObj, const List& args);
  JSValue* widgetProtoFuncGetIsNetworkAvailable(ExecState* exec, JSObject* thisObj, const List& args);
  JSValue* widgetProtoFuncResizeWindow(ExecState* exec, JSObject* thisObj, const List&);
  JSValue* widgetProtoFuncErrorNotify(ExecState* exec, JSObject* thisObj, const List& args);
  JSValue* widgetProtoFuncSetScroll(ExecState* exec, JSObject* thisObj, const List& args);
  JSValue* widgetProtoFuncGetMccMnc(ExecState* exec, JSObject* thisObj, const List& args);

}
#endif
#endif