# Author: Prashant Nevase 
#
# Maintained by: Pushparajan Vijayakumar (rajan.vp@samsung.com)
#
# SISO, Copyright 2008.
###############################################################################

# Convert all DOS path to Cygwin path

TOP := $(subst \,/,$(TOP))
LOGDIR := $(subst \,/,$(LOGDIR))
BUILDDIR := $(subst \,/,$(BUILDDIR))
TOPOUTPUTDIR := $(subst \,/,$(TOPOUTPUTDIR))
APPSBROWSER := $(subst \,/,$(APPSBROWSER))
MAINDIR := $(subst \,/,$(MAINDIR))
BINDIR := $(subst \,/,$(BINDIR))
FS_PATH := $(subst \,/,$(FS_PATH))
SDKROOT := $(subst \,/,$(SDKROOT))
BUILDLOG := $(subst \,/,$(BUILDLOG))

# Add compiler environments here
ifeq ($(CURRENT_TARGET), RVCT)
	include $(MAINDIR)/mkrulesSHPRVCT.inc
else
	ifeq ($(CURRENT_TARGET), ADS)
		include $(MAINDIR)/mkrulesSHPADS.inc
	else
	# TODO: Add more compilers here
	endif
endif

# Windows Visual studio 2005 compiler

CL := cl
CLFLAGS := /w /nologo /Tc

VCBUILD := vcbuild
VCBUILDPARAMS := /useenv /nologo
# Cygwin command defines
# REQUIRES: all the below commands in PATH variable


RM := rm -rf
MD := mkdir -p
CP := cp -rvf
SED := sed
MAKE := make

# Dependency file creater
DEP_FILE=$(@F:.o=.dep)


# Temporary dependency file
D_FILE := temp.d

# error file
ERRFILE := $(LOGDIR)/error.log

mainoutputdir:
	@$(MD) $(TOPOUTPUTDIR)
	@$(MD) $(APPSBROWSER)
ifeq ($(findstring -D_JASMINE_ECOM, $(TARGET_BUILD_SHP_OPTION)), -D_JASMINE_ECOM)
	@$(MD) $(BINDIR)
endif

cleanmainoutputdir:
	$(RM) $(TOPOUTPUTDIR)
	$(RM) $(APPSBROWSER)
ifeq ($(findstring -D_JASMINE_ECOM, $(TARGET_BUILD_SHP_OPTION)), -D_JASMINE_ECOM)
	$(RM) $(BINDIR)
endif
	#clean temporary dirs
	-$(RM) vsn.txt temp.txt _tmp_a_list _tmp_objs
	-$(RM) $(APPSBROWSER)/_shp_depend $(FULLDEPENDS)

