/*
* ==============================================================================
*  Name        : CMMDefs.h
*  Part of     : WebEngine / WEBKIT / MemMan
*  Interface   : 
*  Description : 
*  Version     : %Version%
*
* ==============================================================================
*/
#ifndef __CMMDEFS_H__
#define __CMMDEFS_H__

#include "MemoryManager.h"
#include "ObjectBase.h"

#if 1 // <TODO> : replace with #ifdef __CMM__ once the Browser UI dependency on WTF is removed

// base class with overloaded new/delete operator
#define CMM_MODIFIED : public CObjectBase
#define CMM_MODIFIED_ADD , public CObjectBase
#define CMM_OVERLOAD_NEW_DELETE	static void* operator new( guint size ) 	{ return CObjectBase::operator new(size); }\
								static void operator delete( void* ptr )	{ CObjectBase::operator delete(ptr); }\
                                static void* operator new []( guint size ) 	{ return CObjectBase::operator new(size); }\
                                static void operator delete []( void* ptr )	{ CObjectBase::operator delete(ptr); }\
                                static void* operator new( guint size, void* ptr )   { return CObjectBase::operator new(size, ptr); }\
                                static void operator delete( void* buff, void* ptr )  { CObjectBase::operator delete(buff, ptr); }
								
// precheck and postcheck macros, the function shouldn't between precheck and postcheck pair.
// usage:
// 			CMM_PRE_CHECK( 100000, "MemoryConsumer::consume" )
//			.... your code without return.
// 			CMM_POST_CHECK_FAILED { return_with_oom; }
//			.... your normal return.
#define CMM_PRE_CHECK(s, m, c)	{ if( MemoryManager::PreCheck( s, m, c ) ) { 
#define CMM_POST_CHECK_FAILED(__r) 		} } if( MemoryManager::PostCheck() != CMM_CHECKRESULT_NO_CMM ) { __r;}

#else	// not defined __CMM__

// empty macros
#define CMM_MODIFIED
#define CMM_MODIFIED_ADD
#define CMM_OVERLOAD_NEW_DELETE
#define CMM_CRITICAL_PATH_BEGIN(func, sz)
#define CMM_CRITICAL_PATH_END
#define CMM_PRE_CHECK( s, m, c )
#define CMM_POST_CHECK_FAILED(__r)
#define CMM_NEW_DELETE
#define CMM_NEW_DELETE_WITH_ARRAY

#endif

#endif  //__CMMDEFS_H__
