/*
 * This file is part of the DOM implementation for KDE.
 *
 * Copyright (C) 1999 Lars Knoll (knoll@kde.org)
 *           (C) 1999 Antti Koivisto (koivisto@kde.org)
 *           (C) 2000 Dirk Mueller (mueller@kde.org)
 * Copyright (C) 2004, 2005, 2006 Apple Computer, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */
#if defined(SHP_SUPPORT_WML)
#ifndef WMLOptionElement_h
#define WMLOptionElement_h

#include "HTMLOptionElement.h"
#include "CSSHelper.h"


namespace WebCore {

class WMLSelectElement;

class WMLOptionElement : public HTMLOptionElement
{
    //friend class HTMLSelectElement;
    //friend class RenderMenuList;

public:
    WMLOptionElement(Document*, HTMLFormElement* = 0);
	String onpick() const;
	String valueAttribute() const ;
	virtual bool checkDTD(const Node* newChild);
 
	//not sure whether we should override below functions or not
	//virtual void parseMappedAttribute(MappedAttribute*);
    //void setSelected(bool);
    virtual void setSelectedState(bool);

	virtual void defaultEventHandler(Event* evt) ;

	WMLSelectElement* getSelect() const;
	void removeOptionFromVariableValue(String varName, String varValue) const;
	void updateVariableValue(String varName, String varValue, WMLSelectElement *pSelect) const;
    //HTMLSelectElement* getSelect() const;
};

} //namespace

#endif
#endif //SHP_SUPPORT_WML
