/*
 * Copyright (C) 1999 Lars Knoll (knoll@kde.org)
 *           (C) 1999 Antti Koivisto (koivisto@kde.org)
 * Copyright (C) 2004, 2005, 2006, 2007 Apple Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */
#if defined(SHP_SUPPORT_WML)
#include "config.h"
#include "HTMLNames.h"
#include "WMLPostfieldElement.h"
#include "WMLDocument.h"

namespace WebCore {

using namespace HTMLNames;

WMLPostfieldElement::WMLPostfieldElement(Document *doc)
:HTMLElement(postfieldTag,doc)
{

}
WMLPostfieldElement::~WMLPostfieldElement()
{

}

void WMLPostfieldElement::handleEvent(EventType eventType, bool bForwardNavigation, bool & bIsEventHandled)
{
	//Do the postfield task here

	//No need to call children handleEvent as it has no children
}

String WMLPostfieldElement::getNameAttr()
{
	String value ;
	String *temp = document()->frame()->getVariableReplacedString \
			(getAttribute(nameAttr).domString(), WMLBrowserContext::ENoEscape) ;
	if (temp)
		value = temp->copy() ;
	return value ;
}

String WMLPostfieldElement::getValueAttr()
{
	String value ;
	String *temp = document()->frame()->getVariableReplacedString \
			(getAttribute(valueAttr).domString(), WMLBrowserContext::ENoEscape) ;
	if (temp)
		value = temp->copy() ;
	return value ;
}

} //WebCore
#endif
