//#if defined(SFB_SUPPORT_WMLSCRIPT)

#ifndef WMLSCRIPT_INTERFACE
#define WMLSCRIPT_INTERFACE
#include "config.h"

#include "PlatformString.h"
#include "StringHash.h"
#include <wtf/HashMap.h>
#include "CachedScript.h"
#include "WMLDocument.h"
#include "FrameLoader.h"
#include "WMLGoElement.h"
#include "WMLCardElement.h"
#include "Node.h"

#if PLATFORM(SHP)
#include "CMMDefs.h"
#endif // PLATFORM(SHP)

//#include "WMLScriptInterface.h"
//#include "Wmlsec.h"


using namespace WebCore ;
namespace WebCore {
class WMLScript ;
class WMLCachedScript;						
class WMLDocument ;
class FrameLoader ;
class WMLGoElement ;
class WmlCardElement ;

class WMLScript 
CMM_MODIFIED
{
	typedef HashMap<String, WMLCachedScript *> WMLScriptMap;
	WMLScriptMap m_cachedScriptMap ;
	
	WMLDocument* m_doc ;
	char *goElt ;
	char *prevElt ;
	WMLCachedScript* pscript ;
	char *app_buffer ;
	int p_buflen ;
	bool refreshTaskValue ;

public :
	void* m_scriptHandle ; /* Needed as t will be accessed by the cached script also */
	char *contentType ;

	String downloadUrl ;

	String onEventUrl ;
	String onEventFragment ;

	WMLScript (WMLDocument *doc) ;
	~WMLScript() ;

	void CompileContent( const String& url,char* buffer, int bufferLen, String charset ) ;
	bool IsCompiledUrl( const char* ) ; 
	void terminateExecution ( void ) ;
	int GetDocumentCharset ( void ) ;

	void CompileExecuteScript ( const String& url, char* buffer, int bufferLen ) ;

	void bufferContent (const String& url, char *buffer, int bufferLen ) ;
	void exeScript(const String& targetUrlPrefix, String &fragment ) ;
	//void exeScript(const String& url, String &fragment, String targetUrlPrefix, String docUrlPrefix) ;
	void setcompiledBuffer( const String& url, char *buffer, int bufferLen ) ;
	void getcompiledBuffer( const String& url, char **app_buffer, int *p_buflen) ; 
	void addCachedScript (const String &url, WMLCachedScript* cachedScript) ;

	void setBuffer (char * buffer, int bufferLen ) ;

	//callback interfaces for the browser context
	void newBrowserContext () ;
	char *getCurrentCard () ;
	char *getCurrentUrl () ;
	char *getContextVariableValue (char *name) ;
	bool isValidVariable (char *name) ;
	void refreshBrowserDisplay () ;
	void setVariableValue (char *name, char *value) ;
	void setGoElement ( char* value) ;
	void setPrevElement (char *value) ;
	void resumeScriptExec(char *value) ;

	void ExtUrlDownload(char *value) ;
	void DownloadUrl(char *value, char *contentype) ;

	bool isWmlScriptSuspended() ;
	bool isWmlScriptExecuting() ;
	bool isWmlScriptIdle() ;
	bool isWmlScriptOnEventExecuting() ;

	void setWmlsecStateOnEventExecuting() ;

	void setWmlsecOnEventParams(String &url, String &fragment) ;
	void setWmlsecExecOnEventScript(String &scriptUrl) ;

	bool WmlScriptAlert(const char *message);
	bool WmlScriptConfirm(const char *message,const char *okText,const char *cancelText);
	bool WmlScriptPrompt(const char *message,const char *defInp);
};
}
#endif//WMLSCRIPT_INTERFACE
//#endif//SFB_SUPPORT_WMLSCRIPT