/*
 *  Copyright (c)  SISO, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */
/**
 * @file		AdBlocker.h
 * @brief		implement AdBlocker
 * @author	Gnanasekar.s (Gnanasekar.s@samsung.com) 
 * @version	1.0
 * @date		2008.08.18	v1.0		Created			Gnanasekar.S				
 **/
#ifdef SFB_ADBLOCKER_FEATURE 

#ifndef __ADBLOCKER_H__
#define __ADBLOCKER_H__

#include "StringHash.h"
#include "regexp.h"

class AdBlocker
{
	public:
		AdBlocker();
		~AdBlocker();
		static void Init();
		static void Finalize();
		static bool isAd_Banner(WebCore::String& s); 
	private:
		static void CreateStateMachineObject();

	private:
		static AdBlocker* m_AdBlocker;
		PassRefPtr<KJS::RegExp> m_abRegExp;

};


#endif
#endif