#ifdef USE_NATIVE_WIDGET_SUPPORT

#ifndef NativeComboField_h
#define NativeComboField_h

#include "PlatformString.h"
#include "IntRect.h"
#include "Node.h" 
#include "HTMLSelectElement.h"

#if PLATFORM(SHP)
#include "CMMDefs.h"
#endif // PLATFORM(SHP)

#if PLATFORM(SHP)
typedef int HWIN;
#endif

namespace WebCore {

class RenderStyle;
class Document;

typedef struct _NativeComboBoxAttrib
{

	_NativeComboBoxAttrib() :
	m_rect(0, 0, 0, 0),
    m_pStyle(NULL),
	m_pDocument(NULL),
	m_pSelectElement(NULL),
	m_nodeID(Node::ID_NONE)
 {

 }
 IntRect				m_rect;
 RenderStyle*			m_pStyle;
 Document*				m_pDocument;
 HTMLSelectElement*		m_pSelectElement;
 Node::NodeId			m_nodeID;
 
} NativeComboBoxAttrib;

class NativeComboField
CMM_MODIFIED
{
public :

	static NativeComboField* getNativeComboFieldInstance();
	static void destroyNativeComboFieldInstance();
	void create(const NativeComboBoxAttrib& attribute);	
	void activate(const NativeComboBoxAttrib& attribute);
#if PLATFORM(SHP)
	void deactivate( bool bShow = true );
#else
	void deactivate();
#endif
	void addItem(String value, unsigned index, bool bEnable);
	bool isActivated() const;
	void unsetFocusedNode();
	~NativeComboField();
	const Document* getDocument() { return m_pDocument; }
	HTMLSelectElement* getElement() { return m_pSelectElement; }
	void SetSelectedIndex();
#if PLATFORM(SHP)
	//vamsi - API for Engine to set Current selection to Winset
	void setCurSelItem(int index);
#endif

private :

	void _createComboBox(const NativeComboBoxAttrib& attrib);
	NativeComboField();

	Document*				m_pDocument;
	HTMLSelectElement*		m_pSelectElement;
	Node::NodeId			m_nodeID;
	int						m_selectedIndex;

#if PLATFORM(SHP)
	HWIN m_handleWin;
#endif

};


}  // namespace WebCore

#endif // NativeComboField_h

#endif //#ifdef USE_NATIVE_WIDGET_SUPPORT

