#if defined(USE_NATIVE_WIDGET_SUPPORT) && defined(USE_LIST_BOX_SUPPORT)

#ifndef NativeListBox_h
#define NativeListBox_h

#include "PlatformString.h"
#include "IntRect.h"
#include "Node.h" 
#include "HTMLSelectElement.h"

#if PLATFORM(SHP)
#include "CMMDefs.h"
#endif //PLATFORM(SHP)

#if PLATFORM(SHP)
typedef int HWIN;
#endif

namespace WebCore {

class RenderStyle;
class Document;

typedef struct _NativeListBoxAttrib
{

	_NativeListBoxAttrib() :
	m_rect(0, 0, 0, 0),
    m_pStyle(NULL),
	m_pDocument(NULL),
	m_pSelectElement(NULL),
	m_nodeID(Node::ID_NONE)
 {

 }
 IntRect				m_rect;
 RenderStyle*			m_pStyle;
 Document*				m_pDocument;
 HTMLSelectElement*		m_pSelectElement;
 Node::NodeId			m_nodeID;
 
} NativeListBoxAttrib;

class NativeListBox
CMM_MODIFIED
{
public :

	static NativeListBox* getNativeListBoxInstance();
	static void destroyNativeListBoxInstance();
	void create(const NativeListBoxAttrib& attribute);	
	void activate(const NativeListBoxAttrib& attribute);
	void deactivate();
	void addItem(String value, unsigned index, bool bEnable);
	bool isActivated() const;
	void unsetFocusedNode();
	~NativeListBox();
	const Document* getDocument() { return m_pDocument; }
	HTMLSelectElement* getElement() { return m_pSelectElement; }
	void SetSelectedIndex(bool bSelect);
	void setCurSelItem(int index);
	HWIN GetWindowHandle();
	void SetCountOfItems(int iCount);

	BOOL GetItemValue(int iIndex);
	void SetItemValue(int iIndex, BOOL bValue);
	Vector<BOOL> m_ItemValues;

private :

	void _createListBox(const NativeListBoxAttrib& attrib);
	NativeListBox();

	Document*				m_pDocument;
	HTMLSelectElement*		m_pSelectElement;
	Node::NodeId			m_nodeID;
	int						m_selectedIndex;
	HWIN m_handleWin;
};


}  // namespace WebCore

#endif // NativeListBox_h

#endif //#if defined(USE_NATIVE_WIDGET_SUPPORT) && defined(USE_LIST_BOX_SUPPORT)

