/*
 * Copyright (C) 2006 Michael Emmel mike.emmel@gmail.com 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE COMPUTER, INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE COMPUTER, INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef KeyboardCodes_h
#define KeyboardCodes_h

namespace WebCore {

// VK_LBUTTON (01) Left mouse button
// VK_RBUTTON (02) Right mouse button
// VK_CANCEL (03) Control-break processing
// VK_MBUTTON (04) Middle mouse button (three-button mouse)
// VK_XBUTTON1 (05)
// VK_XBUTTON2 (06)

// VK_BACK (08) BACKSPACE key
# ifndef VK_BACK
 const int VK_BACK = 0x08;
# endif

// VK_TAB (09) TAB key
# ifndef VK_TAB
const int VK_TAB = 0x09;
# endif

// VK_CLEAR (0C) CLEAR key
# ifndef VK_CLEAR
const int VK_CLEAR = 0x0C;
# endif

// VK_RETURN (0D)
# ifndef VK_RETURN
const int VK_RETURN = 0x0D;
# endif

// VK_SHIFT (10) SHIFT key
# ifndef VK_SHIFT
const int VK_SHIFT = 0x10;
# endif
// VK_CONTROL (11) CTRL key
# ifndef VK_CONTROL
const int VK_CONTROL = 0x11;
# endif

// VK_MENU (12) ALT key
# ifndef VK_MENU
const int VK_MENU = 0x12;
# endif
// VK_PAUSE (13) PAUSE key
# ifndef VK_PAUSE
const int VK_PAUSE = 0x13;
# endif
// VK_CAPITAL (14) CAPS LOCK key
# ifndef VK_CAPITAL
const int VK_CAPITAL = 0x14;
# endif
// VK_KANA (15) Input Method Editor (IME) Kana mode
# ifndef VK_KANA
const int VK_KANA = 0x15;
# endif
// VK_HANGUEL (15) IME Hanguel mode (maintained for compatibility; use VK_HANGUL)
// VK_HANGUL (15) IME Hangul mode
# ifndef VK_HANGUL
const int VK_HANGUL = 0x15;
# endif

// VK_JUNJA (17) IME Junja mode
# ifndef VK_JUNJA
const int VK_JUNJA = 0x17;
# endif
// VK_FINAL (18) IME final mode
# ifndef VK_PAUSE
const int VK_FINAL = 0x18;
# endif
// VK_HANJA (19) IME Hanja mode
# ifndef VK_HANJA
const int VK_HANJA = 0x19;
# endif
// VK_KANJI (19) IME Kanji mode
# ifndef VK_KANJI
const int VK_KANJI = 0x19;
# endif
// VK_ESCAPE (1B) ESC key
# ifndef VK_ESCAPE
const int VK_ESCAPE = 0x1B;
# endif
// VK_CONVERT (1C) IME convert

# ifndef VK_CONVERT
const int VK_CONVERT = 0x1C;
# endif
// VK_NONCONVERT (1D) IME nonconvert
# ifndef VK_NONCONVERT
const int VK_NONCONVERT = 0x1D;
# endif

// VK_ACCEPT (1E) IME accept
# ifndef VK_NONCONVERT
const int VK_ACCEPT = 0x1E;
# endif
// VK_MODECHANGE (1F) IME mode change request

# ifndef VK_NONCONVERT
const int VK_MODECHANGE = 0x1F;
# endif
// VK_SPACE (20) SPACEBAR

# ifndef VK_SPACE
const int VK_SPACE = 0x20;
# endif
// VK_PRIOR (21) PAGE UP key
# ifndef VK_PRIOR
const int VK_PRIOR = 0x21;
# endif
// VK_NEXT (22) PAGE DOWN key
# ifndef VK_NEXT

const int VK_NEXT = 0x22;
# endif
// VK_END (23) END key
# ifndef VK_END

const int VK_END = 0x23;
# endif
# ifndef VK_HOME
// VK_HOME (24) HOME key
const int VK_HOME = 0x24;
# endif
// VK_LEFT (25) LEFT ARROW key
# ifndef VK_LEFT
const int VK_LEFT = 0x25;
# endif
// VK_UP (26) UP ARROW key
# ifndef VK_UP
const int VK_UP = 0x26;
# endif
// VK_RIGHT (27) RIGHT ARROW key
# ifndef VK_RIGHT
const int VK_RIGHT = 0x27;
# endif
// VK_DOWN (28) DOWN ARROW key
# ifndef VK_DOWN
const int VK_DOWN = 0x28;
# endif
// VK_SELECT (29) SELECT key
# ifndef VK_SELECT
const int VK_SELECT = 0x29;
# endif
// VK_PRINT (2A) PRINT key
# ifndef VK_PRINT
const int VK_PRINT = 0x2A;
# endif
// VK_EXECUTE (2B) EXECUTE key
# ifndef VK_EXECUTE
const int VK_EXECUTE = 0x2B;
# endif
// VK_SNAPSHOT (2C) PRINT SCREEN key
# ifndef VK_SNAPSHOT
const int VK_SNAPSHOT = 0x2C;
# endif
// VK_INSERT (2D) INS key
# ifndef VK_INSERT
const int VK_INSERT = 0x2D;
# endif
// VK_DELETE (2E) DEL key
# ifndef VK_DELETE
const int VK_DELETE = 0x2E;
# endif
// VK_HELP (2F) HELP key
# ifndef VK_HELP
const int VK_HELP = 0x2F;
# endif

// (30) 0 key
# ifndef VK_0
const int VK_0 = 0x30;
# endif

// (31) 1 key
# ifndef VK_1
const int VK_1 = 0x31;
# endif

// (32) 2 key
# ifndef VK_2
const int VK_2 = 0x32;
# endif

// (33) 3 key
# ifndef VK_3
const int VK_3 = 0x33;
# endif

// (34) 4 key
# ifndef VK_4
const int VK_4 = 0x34;
# endif

// (35) 5 key;
# ifndef VK_5
const int VK_5 = 0x35;
# endif

// (36) 6 key
# ifndef VK_6
const int VK_6 = 0x36;
# endif

// (37) 7 key
# ifndef VK_7
const int VK_7 = 0x37;
# endif

// (38) 8 key
# ifndef VK_8
const int VK_8 = 0x38;
# endif

// (39) 9 key
# ifndef VK_9
const int VK_9 = 0x39;
# endif

// (41) A key
# ifndef VK_A
const int VK_A = 0x41;
# endif

// (42) B key
# ifndef VK_B
const int VK_B = 0x42;
# endif

// (43) C key
# ifndef VK_C
const int VK_C = 0x43;
# endif

// (44) D key
# ifndef VK_D
const int VK_D = 0x44;
# endif

// (45) E key
# ifndef VK_E
const int VK_E = 0x45;
# endif

// (46) F key
# ifndef VK_F
const int VK_F = 0x46;
# endif

// (47) G key
# ifndef VK_G
const int VK_G = 0x47;
# endif

// (48) H key
# ifndef VK_H
const int VK_H = 0x48;
# endif

// (49) I key
# ifndef VK_I
const int VK_I = 0x49;
# endif

// (4A) J key
# ifndef VK_J
const int VK_J = 0x4A;
# endif

// (4B) K key
# ifndef VK_K
const int VK_K = 0x4B;
# endif

// (4C) L key
# ifndef VK_L
const int VK_L = 0x4C;
# endif

// (4D) M key
# ifndef VK_M
const int VK_M = 0x4D;
# endif

// (4E) N key
# ifndef VK_N
const int VK_N = 0x4E;
# endif

// (4F) O key
# ifndef VK_O
const int VK_O = 0x4F;
# endif

// (50) P key
# ifndef VK_P
const int VK_P = 0x50;
# endif

// (51) Q key
# ifndef VK_Q
const int VK_Q = 0x51;
# endif

// (52) R key
# ifndef VK_R
const int VK_R = 0x52;
# endif

// (53) S key
# ifndef VK_S
const int VK_S = 0x53;
# endif

// (54) T key
# ifndef VK_T
const int VK_T = 0x54;
# endif

// (55) U key
# ifndef VK_U
const int VK_U = 0x55;
# endif

// (56) V key
# ifndef VK_V
const int VK_V = 0x56;
# endif

// (57) W key
# ifndef VK_W
const int VK_W = 0x57;
# endif

// (58) X key
# ifndef VK_X
const int VK_X = 0x58;
# endif

// (59) Y key
# ifndef VK_Y
const int VK_Y = 0x59;
# endif

// (5A) Z key
# ifndef VK_Z
const int VK_Z = 0x5A;
# endif

// VK_LWIN (5B) Left Windows key (Microsoft Natural keyboard)
# ifndef VK_LWIN
const int VK_LWIN = 0x5B;
# endif

// VK_RWIN (5C) Right Windows key (Natural keyboard)
# ifndef VK_RWIN
const int VK_RWIN = 0x5C;
# endif

// VK_APPS (5D) Applications key (Natural keyboard)
# ifndef VK_APPS
const int VK_APPS = 0x5D;
# endif

// VK_SLEEP (5F) Computer Sleep key
# ifndef VK_SLEEP
const int VK_SLEEP = 0x5F;
# endif

// VK_NUMPAD0 (60) Numeric keypad 0 key
# ifndef VK_NUMPAD0
const int VK_NUMPAD0 = 0x60;
# endif

// VK_NUMPAD1 (61) Numeric keypad 1 key
# ifndef VK_NUMPAD1
const int VK_NUMPAD1 = 0x61;
# endif

// VK_NUMPAD2 (62) Numeric keypad 2 key
# ifndef VK_NUMPAD2
const int VK_NUMPAD2 = 0x62;
# endif

// VK_NUMPAD3 (63) Numeric keypad 3 key
# ifndef VK_NUMPAD3
const int VK_NUMPAD3 = 0x63;
# endif

// VK_NUMPAD4 (64) Numeric keypad 4 key
# ifndef VK_NUMPAD4
const int VK_NUMPAD4 = 0x64;
# endif

// VK_NUMPAD5 (65) Numeric keypad 5 key
# ifndef VK_NUMPAD5
const int VK_NUMPAD5 = 0x65;
# endif

// VK_NUMPAD6 (66) Numeric keypad 6 key
# ifndef VK_NUMPAD6
const int VK_NUMPAD6 = 0x66;
# endif

// VK_NUMPAD7 (67) Numeric keypad 7 key
# ifndef VK_NUMPAD7
const int VK_NUMPAD7 = 0x67;
# endif

// VK_NUMPAD8 (68) Numeric keypad 8 key
# ifndef VK_NUMPAD8
const int VK_NUMPAD8 = 0x68;
# endif

// VK_NUMPAD9 (69) Numeric keypad 9 key
# ifndef VK_NUMPAD9
const int VK_NUMPAD9 = 0x69;
# endif

// VK_MULTIPLY (6A) Multiply key
# ifndef VK_MULTIPLY
const int VK_MULTIPLY = 0x6A;
# endif

// VK_ADD (6B) Add key
# ifndef VK_ADD
const int VK_ADD = 0x6B;
# endif

// VK_SEPARATOR (6C) Separator key
# ifndef VK_SEPARATOR
const int VK_SEPARATOR = 0x6C;
# endif

// VK_SUBTRACT (6D) Subtract key
# ifndef VK_SUBTRACT
const int VK_SUBTRACT = 0x6D;
# endif

// VK_DECIMAL (6E) Decimal key
# ifndef VK_DECIMAL
const int VK_DECIMAL = 0x6E;
# endif

// VK_DIVIDE (6F) Divide key
# ifndef VK_DIVIDE
const int VK_DIVIDE = 0x6F;
# endif

// VK_F1 (70) F1 key
# ifndef VK_F1
const int VK_F1 = 0x70;
# endif

// VK_F2 (71) F2 key
# ifndef VK_F2
const int VK_F2 = 0x71;
# endif

// VK_F3 (72) F3 key
# ifndef VK_F3
const int VK_F3 = 0x72;
# endif

// VK_F4 (73) F4 key
# ifndef VK_F4
const int VK_F4 = 0x73;
# endif

// VK_F5 (74) F5 key
# ifndef VK_F5
const int VK_F5 = 0x74;
# endif

// VK_F6 (75) F6 key
# ifndef VK_F6
const int VK_F6 = 0x75;
# endif

// VK_F7 (76) F7 key
# ifndef VK_F7
const int VK_F7 = 0x76;
# endif

// VK_F8 (77) F8 key
# ifndef VK_F8
const int VK_F8 = 0x77;
# endif

// VK_F9 (78) F9 key
# ifndef VK_F9
const int VK_F9 = 0x78;
# endif

// VK_F10 (79) F10 key
# ifndef VK_F10
const int VK_F10 = 0x79;
# endif

// VK_F11 (7A) F11 key
# ifndef VK_F11
const int VK_F11 = 0x7A;
# endif

// VK_F12 (7B) F12 key
# ifndef VK_F12
const int VK_F12 = 0x7B;
# endif

// VK_F13 (7C) F13 key
# ifndef VK_F13
const int VK_F13 = 0x7C;
# endif

// VK_F14 (7D) F14 key
# ifndef VK_F14
const int VK_F14 = 0x7D;
# endif

// VK_F15 (7E) F15 key
# ifndef VK_F15
const int VK_F15 = 0x7E;
# endif

// VK_F16 (7F) F16 key
# ifndef VK_F16
const int VK_F16 = 0x7F;
# endif

// VK_F17 (80H) F17 key
# ifndef VK_F17
const int VK_F17 = 0x80;
# endif

// VK_F18 (81H) F18 key
# ifndef VK_F18
const int VK_F18 = 0x81;
# endif

// VK_F19 (82H) F19 key
# ifndef VK_F19
const int VK_F19 = 0x82;
# endif

// VK_F20 (83H) F20 key
# ifndef VK_F20
const int VK_F20 = 0x83;
# endif

// VK_F21 (84H) F21 key
# ifndef VK_F21
const int VK_F21 = 0x84;
# endif

// VK_F22 (85H) F22 key
# ifndef VK_F22
const int VK_F22 = 0x85;
# endif

// VK_F23 (86H) F23 key
# ifndef VK_F23
const int VK_F23 = 0x86;
# endif

// VK_F24 (87H) F24 key
# ifndef VK_F24
const int VK_F24 = 0x87;
# endif

// VK_NUMLOCK (90) NUM LOCK key
# ifndef VK_NUMLOCK
const int VK_NUMLOCK = 0x90;
# endif

// VK_SCROLL (91) SCROLL LOCK key
# ifndef VK_SCROLL
const int VK_SCROLL = 0x91;
# endif

// VK_LSHIFT (A0) Left SHIFT key
# ifndef VK_LSHIFT
const int VK_LSHIFT = 0xA0;
# endif

// VK_RSHIFT (A1) Right SHIFT key
# ifndef VK_RSHIFT
const int VK_RSHIFT = 0xA1;
# endif

// VK_LCONTROL (A2) Left CONTROL key
# ifndef VK_LCONTROL
const int VK_LCONTROL = 0xA2;
# endif

// VK_RCONTROL (A3) Right CONTROL key
# ifndef VK_RCONTROL
const int VK_RCONTROL = 0xA3;
# endif

// VK_LMENU (A4) Left MENU key
# ifndef VK_LMENU
const int VK_LMENU = 0xA4;
# endif

// VK_RMENU (A5) Right MENU key
# ifndef VK_RMENU
const int VK_RMENU = 0xA5;
# endif

// VK_BROWSER_BACK (A6) Windows 2000/XP: Browser Back key
# ifndef VK_BROWSER_BACK
const int VK_BROWSER_BACK = 0xA6;
# endif

// VK_BROWSER_FORWARD (A7) Windows 2000/XP: Browser Forward key
# ifndef VK_BROWSER_FORWARD
const int VK_BROWSER_FORWARD = 0xA7;
# endif

// VK_BROWSER_REFRESH (A8) Windows 2000/XP: Browser Refresh key
# ifndef VK_BROWSER_REFRESH
const int VK_BROWSER_REFRESH = 0xA8;
# endif

// VK_BROWSER_STOP (A9) Windows 2000/XP: Browser Stop key
# ifndef VK_BROWSER_STOP
const int VK_BROWSER_STOP = 0xA9;
# endif

// VK_BROWSER_SEARCH (AA) Windows 2000/XP: Browser Search key
# ifndef VK_BROWSER_SEARCH
const int VK_BROWSER_SEARCH = 0xAA;
# endif

// VK_BROWSER_FAVORITES (AB) Windows 2000/XP: Browser Favorites key
# ifndef VK_BROWSER_FAVORITES
const int VK_BROWSER_FAVORITES = 0xAB;
# endif

// VK_BROWSER_HOME (AC) Windows 2000/XP: Browser Start and Home key
# ifndef VK_BROWSER_HOME
const int VK_BROWSER_HOME = 0xAC;
# endif

// VK_VOLUME_MUTE (AD) Windows 2000/XP: Volume Mute key
# ifndef VK_VOLUME_MUTE
const int VK_VOLUME_MUTE = 0xAD;
# endif

// VK_VOLUME_DOWN (AE) Windows 2000/XP: Volume Down key
# ifndef VK_VOLUME_DOWN
const int VK_VOLUME_DOWN = 0xAE;
# endif

// VK_VOLUME_UP (AF) Windows 2000/XP: Volume Up key
# ifndef VK_VOLUME_UP
const int VK_VOLUME_UP = 0xAF;
# endif

// VK_MEDIA_NEXT_TRACK (B0) Windows 2000/XP: Next Track key
# ifndef VK_MEDIA_NEXT_TRACK
const int VK_MEDIA_NEXT_TRACK = 0xB0;
# endif

// VK_MEDIA_PREV_TRACK (B1) Windows 2000/XP: Previous Track key
# ifndef VK_MEDIA_PREV_TRACK
const int VK_MEDIA_PREV_TRACK = 0xB1;
# endif

// VK_MEDIA_STOP (B2) Windows 2000/XP: Stop Media key
# ifndef VK_MEDIA_STOP
const int VK_MEDIA_STOP = 0xB2;
# endif

// VK_MEDIA_PLAY_PAUSE (B3) Windows 2000/XP: Play/Pause Media key
# ifndef VK_MEDIA_PLAY_PAUSE
const int VK_MEDIA_PLAY_PAUSE = 0xB3;
# endif

// VK_LAUNCH_MAIL (B4) Windows 2000/XP: Start Mail key
# ifndef VK_MEDIA_LAUNCH_MAIL
const int VK_MEDIA_LAUNCH_MAIL = 0xB4;
# endif

// VK_LAUNCH_MEDIA_SELECT (B5) Windows 2000/XP: Select Media key
# ifndef VK_MEDIA_LAUNCH_MEDIA_SELECT
const int VK_MEDIA_LAUNCH_MEDIA_SELECT = 0xB5;
# endif

// VK_LAUNCH_APP1 (B6) Windows 2000/XP: Start Application 1 key
# ifndef VK_MEDIA_LAUNCH_APP1
const int VK_MEDIA_LAUNCH_APP1 = 0xB6;
# endif

// VK_LAUNCH_APP2 (B7) Windows 2000/XP: Start Application 2 key
# ifndef VK_MEDIA_LAUNCH_APP2
const int VK_MEDIA_LAUNCH_APP2 = 0xB7;
# endif

// VK_OEM_1 (BA) Used for miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the ';:' key
# ifndef VK_OEM_1
const int VK_OEM_1 = 0xBA;
# endif

// VK_OEM_PLUS (BB) Windows 2000/XP: For any country/region, the '+' key
# ifndef VK_OEM_PLUS
const int VK_OEM_PLUS = 0xBB;
# endif

// VK_OEM_COMMA (BC) Windows 2000/XP: For any country/region, the ',' key
# ifndef VK_OEM_COMMA
const int VK_OEM_COMMA = 0xBC;
# endif

// VK_OEM_MINUS (BD) Windows 2000/XP: For any country/region, the '-' key
# ifndef VK_OEM_MINUS
const int VK_OEM_MINUS = 0xBD;
# endif

// VK_OEM_PERIOD (BE) Windows 2000/XP: For any country/region, the '.' key

# ifndef VK_OEM_PERIOD
const int VK_OEM_PERIOD = 0xBE;
# endif

// VK_OEM_2 (BF) Used for miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the '/?' key
# ifndef VK_OEM_2
const int VK_OEM_2 = 0xBF;
# endif

// VK_OEM_3 (C0) Used for miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the '`~' key
# ifndef VK_OEM_3
const int VK_OEM_3 = 0xC0;
# endif

// VK_OEM_4 (DB) Used for miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the '[{' key
# ifndef VK_OEM_4
const int VK_OEM_4 = 0xDB;
# endif

// VK_OEM_5 (DC) Used for miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the '\|' key
# ifndef VK_OEM_5
const int VK_OEM_5 = 0xDC;
# endif

// VK_OEM_6 (DD) Used for miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the ']}' key
# ifndef VK_OEM_6
const int VK_OEM_6 = 0xDD;
# endif

// VK_OEM_7 (DE) Used for miscellaneous characters; it can vary by keyboard. Windows 2000/XP: For the US standard keyboard, the 'single-quote/double-quote' key
# ifndef VK_OEM_7
const int VK_OEM_7 = 0xDE;
# endif

// VK_OEM_8 (DF) Used for miscellaneous characters; it can vary by keyboard.
# ifndef VK_OEM_8
const int VK_OEM_8 = 0xDF;
# endif

// VK_OEM_102 (E2) Windows 2000/XP: Either the angle bracket key or the backslash key on the RT 102-key keyboard
# ifndef VK_OEM_102
const int VK_OEM_102 = 0xE2;
# endif

// VK_PROCESSKEY (E5) Windows 95/98/Me, Windows NT 4.0, Windows 2000/XP: IME PROCESS key
# ifndef VK_PROCESSKEY
const int VK_PROCESSKEY = 0xE5;
# endif

// VK_PACKET (E7) Windows 2000/XP: Used to pass Unicode characters as if they were keystrokes. The VK_PACKET key is the low word of a 32-bit Virtual Key value used for non-keyboard input methods. For more information, see Remark in KEYBDINPUT,SendInput, WM_KEYDOWN, and WM_KEYUP
# ifndef VK_PACKET
const int VK_PACKET = 0xE7;
# endif

// VK_ATTN (F6) Attn key
# ifndef VK_ATTN
const int VK_ATTN = 0xF6;
# endif

// VK_CRSEL (F7) CrSel key
# ifndef VK_CRSEL
const int VK_CRSEL = 0xF7;
# endif

// VK_EXSEL (F8) ExSel key
# ifndef VK_EXSEL
const int VK_EXSEL = 0xF8;
# endif

// VK_EREOF (F9) Erase EOF key
# ifndef VK_EREOF
const int VK_EREOF = 0xF9;
# endif

// VK_PLAY (FA) Play key
# ifndef VK_PLAY
const int VK_PLAY = 0xFA;
# endif

// VK_ZOOM (FB) Zoom key
# ifndef VK_ZOOM
const int VK_ZOOM = 0xFB;
# endif

// VK_NONAME (FC) Reserved for future use
# ifndef VK_NONAME
const int VK_NONAME = 0xFC;
# endif

// VK_PA1 (FD) PA1 key
# ifndef VK_PA1
const int VK_PA1 = 0xFD;
# endif

// VK_OEM_CLEAR (FE) Clear key
# ifndef VK_OEM_CLEAR
const int VK_OEM_CLEAR = 0xFE;
# endif

# ifndef VK_UNKNOWN
const int VK_UNKNOWN = 0;
# endif

}

#endif