
#ifdef SUPPORT_NP_PLUGIN 

#include "RenderPlugin.h"
#include "GraphicsContext.h"
#include "LoadListeners.h"

namespace WebCore {

RenderPlugin::RenderPlugin(HTMLFrameOwnerElement* element)
    : RenderPartObject(element)
{
}

void RenderPlugin::paint(PaintInfo& paintInfo, int tx, int ty)
{
    ASSERT( m_pluginHandle );

    // Update the paint event to the plugin
    IntRect rect = node()->getRect();

    rect.setX( paintInfo.context->translateX( rect.x() ) );
    rect.setY( paintInfo.context->translateY( rect.y() ) ); 

    // <TODO> : No need to pass the GC
    m_pluginHandle->PaintPlugin( *paintInfo.context->platformContext(), rect );
}

} // namespace WebCore

#endif // SUPPORT_NP_PLUGIN

// End of File
