#ifndef CONTENTDISPATCHER_H
#define CONTENTDISPATCHER_H

//  INCLUDES
#include "BridgeTypes.h"
#include "ContentListener.h"
#include <wtf/Vector.h>
#include "CMMDefs.h"

// CONSTANTS

// MACROS

// DATA TYPES

// FUNCTION PROTOTYPES

// FORWARD DECLARATIONS
class IContentListener;
class BaseTransaction;
class UrlResponseInfo;
// CLASS DECLARATION

class TransactionEntry CMM_MODIFIED
    {
	public: // Constructor and Destructor
		TransactionEntry( )
			: m_contentListener( NULL )
		{
		}

		~TransactionEntry( )
		{
			delete m_contentListener;
            m_contentListener = NULL;
		}

    public : // data
        //
        int m_transactionId;
        //
        IContentListener* m_contentListener;
    };

class ContentDispatcher CMM_MODIFIED
    {
    public:  // Constructors and destructor

        /**
        * Constructor.
        */
        ContentDispatcher();

        /**
        * Destructor.
        */
        virtual ~ContentDispatcher();

    public: // New functions

        /**
        *
        * @param
        * @return
        */
        eErrorCode SetContentListener( const int _transactionId, IContentListener* _contentListener );

		eErrorCode RemoveContentListener( const int _transactionId );

    public: 

        /**
        *
        * @param
        * @return ERR_NOT_SUPPORTED if it is not a native browser content
        */
        eErrorCode Headers( BaseTransaction* _transaction, UrlResponseInfo* _response );

        /**
        *
        * @param
        * @return
        */
        void Response( BaseTransaction* _transaction, UrlResponseInfo* _response );

        /**
        *
        * @param
        * @return
        */
        void Complete( BaseTransaction* _transaction, UrlResponseInfo* _response, eErrorCode _error );

        /**
        *
        * @param
        * @return
        */
        void HandleError( int _transactionId, int _error );

        /**
        * lock
        */
        void Ref() { ++m_refCount; }

        /**
        * unlock
        * @since 3.1
        */
        void Deref() { if( --m_refCount == 0 ) delete this; }

        /**
        *
        * @param
        * @return
        */
        TransactionEntry* FindTransactionEntry( const int _transactionId );

        /**
        *
        * @param
        * @return
        */
        TransactionEntry* FindTransactionEntry( const WebCore::ResourceLoader* _resourceLoader );

    private:

        /**
        *
        * @param
        * @return
        */
        eErrorCode AddTransactionEntry( const int _transactionId, IContentListener* _contentListener);

        /**
        *
        * @param
        * @return
        */
        eErrorCode RemoveTransactionEntry( int _transactionId );

        /**
        *
        * @param
        * @return
        */
        eErrorCode ClearTransactionList();

    private:    // Data

        // array to hold TransactionEntry structures
        Vector<TransactionEntry*> m_transactionEntries; // owned
        //
        int            m_refCount;
    };

#endif      // CONTENTDISPATCHER_H

// End of File

