#ifndef ICONTENTLOADER_H
#define ICONTENTLOADER_H

#include "BridgeTypes.h"

class UrlRequestInfo;
class BaseTransaction;
// CLASS DECLARATION

/**
*  This class provides an interface for the resource loader client
*  to manage transactions
*  @lib resLoader.lib
*/
class IContentLoader
    {
    public: // New functions
        
        /**
        * Request a url.
        * @param _requestInfo Url request info created by the resloader client.
        * @return OS wide error code.
        */
        virtual eErrorCode Request( UrlRequestInfo* _requestInfo ) = 0;       

        /**
        * Cancell all outstanding transactions.
        * @param _error This error code is propagated up to
        * the resource loader client through Complete()
        * @return ErrNotFound if there is not outstanding transaction.
        */
        virtual eErrorCode CancelAll( eErrorCode _error = ERR_OK ) = 0;       
    };

#endif      // ICONTENTLOADER_H
            
// End of File
