#ifndef FILELOADER_H
#define FILELOADER_H

//  INCLUDES
#include "UrlLoader.h"

// CONSTANTS

// MACROS

// DATA TYPES

// FUNCTION PROTOTYPES

// FORWARD DECLARATIONS
class ContentDispatcher;

// CLASS DECLARATION

/**
*  This is a file loader class. It handles tranasactions with file:// scheme
*  @lib resLoader.lib
*/
class FileLoader : public UrlLoader
    {
    public:  // Constructors and destructor        
        
        /**
        * Constructor
        * @param _contentDispatcher This dispatcher takes the incoming chunks
        */
        FileLoader( ContentDispatcher* _contentDispatcher );
        
        /**
        * Destructor.
        */
        virtual ~FileLoader();

    protected: // from UrlLoader

        /**
        * Create a transaction.
        * @param _urlRequestInfo Url request info created by the resource loader client.
        * @return Transaction object.
        */
        BaseTransaction* CreateTransaction( UrlRequestInfo* _urlRequestInfo );
    };

#endif      // CFILELOADER_H
            
// End of File
