// INCLUDE FILES
#include <stdlib.h>
#include "PostDataItem.h"

#ifdef __CMM__
#include <AnsiCLib.h>
#include <allocs.h>
#else
#include "Shp.h"
#endif

// EXTERNAL DATA STRUCTURES

// EXTERNAL FUNCTION PROTOTYPES

// CONSTANTS

// MACROS

// LOCAL CONSTANTS AND MACROS

// MODULE DATA STRUCTURES

// LOCAL FUNCTION PROTOTYPES

// FORWARD DECLARATIONS

// ============================= LOCAL FUNCTIONS ===============================


// ============================ MEMBER FUNCTIONS ===============================

// -----------------------------------------------------------------------------
// Constructor
// -----------------------------------------------------------------------------
//
PostDataItem::PostDataItem(
    const WebCoreFormDataItem& _formDataItem)
    {
		if(_formDataItem.Data())
		{
			m_data = (char *)malloc(AcStrlen(_formDataItem.Data()) + 1);
			AcStrcpy(m_data, _formDataItem.Data());
		}

    }

// -----------------------------------------------------------------------------
// destructor
// -----------------------------------------------------------------------------
//
PostDataItem::~PostDataItem()
    {
    free(m_data);
    }


// -----------------------------------------------------------------------------
// Retuns data contained by the post data itemaSizeOfDataToSupply , size of the data
// to be supplied if the aSizeOfDataToSupply is not supplied , then the content till
// the end of the buffer is returned
// -----------------------------------------------------------------------------
//
char* PostDataItem::Data(
    int _sizeOfDataToSupply )
    {
    char* dataToSupply = NULL;
    int sizeOfDataToSupply= _sizeOfDataToSupply;
    // if sizeOfDataToSupply exceeds the size of data supplied then set the sizeOfDataToSupply
    // to the content size
    if(sizeOfDataToSupply == -1 || sizeOfDataToSupply >= (strlen(m_data) - m_dataOffset))
        {
        sizeOfDataToSupply = strlen(m_data) - m_dataOffset;
        }

    dataToSupply = (char *) MemoryManager::Alloc(sizeOfDataToSupply - m_dataOffset + 1);
    strncpy(dataToSupply, m_data + m_dataOffset, sizeOfDataToSupply - m_dataOffset);

    // add supplied size count to the data offset
    m_dataOffset += sizeOfDataToSupply;
    return  dataToSupply;
    }


// -----------------------------------------------------------------------------
// resets the state of the object
// -----------------------------------------------------------------------------
//
void PostDataItem::Reset()
    {
    m_dataOffset = 0;
    }


// -----------------------------------------------------------------------------
// returns the pending size of the content to be posted
// -----------------------------------------------------------------------------
//
int PostDataItem::PendingContentSize() const
    {
    return strlen(m_data) - m_dataOffset;
    }

// End of File

