#ifndef POSTDATA_H
#define POSTDATA_H

//  INCLUDES

#include "WebCoreFormData.h"
#include "CMMDefs.h"
// CONSTANTS

// MACROS

// DATA TYPES

// FUNCTION PROTOTYPES

// FORWARD DECLARATIONS

// CLASS DECLARATION

/**
*  container of form data
*
*  @lib resloader.lib
*  @since 3.0
*/
class PostDataItem CMM_MODIFIED
  {
  public:
  // public members
    /**
    * Constructor
    * @param _formDataItem post data part
    */
    PostDataItem(const WebCoreFormDataItem& _formDataItem);

    /**
    * Destructor
    */
    virtual ~PostDataItem();

    /**
    * Retuns data contained by the post data item
    * @param _sizeOfDataToSupply , size of the data to be supplied
    *     if the _sizeOfDataToSupply is not supplied , then the content till 
    *     the end of the buffer is returned
    * @return char* 
    */
    virtual char* Data(int _sizeOfDataToSupply = -1);

    /**
    * resets the state of the objects
    */
    virtual void Reset();

    /**
    * Returns amount of data of an item peding to be posted
    * @return int , size left to be posted
    */
    virtual int PendingContentSize() const;


  protected:
    // protected member data
    char* m_data;// owned, post content part 

    unsigned int m_dataOffset;// offset of the data content 
  };

#endif // POSTDATA_H

// End of File

