#ifndef POSTDATAPART_H
#define POSTDATAPART_H

//  INCLUDES

#include "WebCoreFormData.h"
#include "PostDataItem.h"
#include "CMMDefs.h"

// CONSTANTS

// MACROS

// DATA TYPES

// FUNCTION PROTOTYPES

// FORWARD DECLARATIONS
// <TODO> : Add BrowseControl Interface
// class MBrCtlLoadEventObserver;

// CLASS DECLARATION


/**
*  container of array of PostDataItem's, the class is also resposible for 
*  building data part 
*  @lib resloader.lib
*/

class PostDataParts CMM_MODIFIED
    {
    public:
    // public members
    /**
    * Constructors
    * @param _data array of post data items
    */
    PostDataParts(const Vector<WebCoreFormDataItem>& _data);

    /**
    * Destructor
    */
    ~PostDataParts();

    /**
    * returns total size of the content
    * @return int
    */
    int TotalSize();

    /**
    * builds next part to be posted and returns the part to the supplier
    * @param _dataPart, descritor reference to return the part
    * @return bool , true if it is the last content
    */
    bool GetNextDataPart(char* _dataPart);

    /**
    * called by the post data supplier to release data chunk
    */
    void Release();

    /**
    * returns TRUE if there is more post data to be posted to the server
    */
    bool HasMoreParts() const {return !m_lastPart;}


    /**
    * resets the state of the objects
    */
    void Reset();


    void Ref()              { m_refCount++; }

    void Deref()            { if( --m_refCount==0 ) delete this; }

  private:
    // public members
    Vector<PostDataItem*>       m_postDataItems;// owned , array of post data parts  

    char*                       m_dataPart;// owned , part data

    int                         m_totalSize;// total size of the post data

    int                         m_postItemIndex;// post data items track

    bool                        m_lastPart;

    bool                        m_firstPart;

    int                         m_refCount;
  };

#endif

// End of File

