/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		IInputStream..h
 * @brief		Define interface of URILoader IInputStream
 * @author	Sangheon Kim (sangheon77.kim@samsung.com)
 * @version	1.0
 * @date		2008.03.05	v1.0		Created
 */

//#include "Config.h"

#ifndef _IInputStream_Defined
#define _IInputStream_Defined

#include "URILoader.h"

namespace URILoader
{

class IInputStream : public IUnknown
{
public:

	/***************************************************************************
	*
	* Funtions
	*
	****************************************************************************/

	/** 
	 * Close the stream. 
	 */
	virtual void Close() = 0;

	/**
	 * Determine number of bytes available in the stream.  
	 */
	virtual unsigned long Available() = 0;

	/** 
	 * Read data from the stream.
	 */
	virtual unsigned long Read( char* aBuf, unsigned long aCount) = 0;

}; // IInputStream



} // namespace 

#endif //_IInputStream_Defined
