/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		IDecisionSender.h
 * @brief		Define interface IDecisionSender of WebControl
 * @author	Chaehwan Li (chaehwan.li@samsung.com)
 * @version	1.0
 * @date		2008.03.14	v1.0		Created
 */

#ifndef __IDecisionSender_Defined
#define __IDecisionSender_Defined

#include "WebDefs.h"


namespace	WebControl
{

class IDecisionSender
{
public:

	/*
	 * @desc This sender function called when UI decided download.
	 * @param in_pIStreamListener pointer to IStreamListener // removed
	 * @return HRESULT TRUE/FALSE
	 */
	virtual HRESULT download( /*IStreamListener* in_pIStreamListener*/ ) = 0;

	/*
	 * @desc This sender function called when UI decided ignore
	 * @param
	 * @return HRESULT TRUE/FALSE
	 */
	virtual HRESULT ignore( void ) = 0;

	/*
	 * @desc This sender function called when UI decided use
	 * @param
	 * @return HRESULT TRUE/FALSE
	 */
	virtual HRESULT use( void ) = 0;

};

} // namespace WebControl

#endif // __IDecisionSender_Defined