/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		IWindowListener.h
 * @brief		Define interface IWindowListener of WebControl
 * @author	Chaehwan Li (chaehwan.li@samsung.com)
 * @version	1.0
 * @date		2008.03.14	v1.0		Created
 */

#ifndef __IWindowListener_Defined
#define __IWindowListener_Defined

#include "WebDefs.h"
#include "IWindowSender.h"

namespace	WebControl
{

class IControl;

class IWindowListener
{
public:

	/*
	 * @desc
	 * @param in_pszUrl
	 * @param in_pIWindowSender
	 * @return HRESULT
	 */
	virtual HRESULT Open( char* in_pszUrl, IWindowSender* in_pIWindowSender ) = 0;

	/*
	 * @desc
	 * @param in_pIControl
	 * @param in_pIWindowSender
	 * @return HRESULT
	 */
	virtual HRESULT Close( IControl* in_pIControl, IWindowSender* in_pIWindowSender ) = 0;

};

} // namespace WebControl

#endif // __IWindowListener_Defined