/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		IWindowSender.h
 * @brief		Define interface IWindowSender of WebControl
 * @author	Chaehwan Li (chaehwan.li@samsung.com)
 * @version	1.0
 * @date		2008.03.14	v1.0		Created
 */

#ifndef __IWindowSender_Defined
#define __IWindowSender_Defined

#include "WebDefs.h"

namespace	WebControl
{

class IWindowSender
{
public:
	/*
	 * @desc this sender called when result is success.
	 * @param
	 * @return HRESULT TRUE/FALSE
	 */
	virtual HRESULT Success( void ) = 0;

	/*
	 * @desc this sender called when result is fail.
	 * @param
	 * @return HRESULT TRUE / FALSE
	 */
	virtual HRESULT Fail( void ) = 0;

};

} // namespace WebControl

#endif // __IWindowSender_Defined