/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		WebControlConfig.h
 * @brief		Configuration for the implementation of IControl of WebControl
 * @author	Sangheon Kim (sangheon77.kim@samsung.com)
 * @version	1.0
 * @date		2008.03.18	v1.0		Created
 */
#ifndef __WebControlConfig_Defined
#define __WebControlConfig_Defined

#include "string"
#include "SHP.h"

namespace	WebControl
{

/**
* Debug settings
*/
#define MID_WEBCTRL	MID_BROWSER 
#define WebAssert SysAssert
/**
* Types definitions
*/
//typedef stlport::string StringXX;


#define WEBCONTROL_CACHE_STORAGE			"/User/Br/SFB/Cache"
#define WEBCONTROL_COOKIE_STORAGE		"/User/Br/SFB/Cookie"

//#ifdef _SHP_SIMUL
#if 0
#define __NotImplemented() SysDebug(( MID_EXCEPTION, "[%s] not implemented\n", __FUNCTION__ ))
#define __NotRequired() SysDebug(( MID_EXCEPTION, "[%s] not required\n", __FUNCTION__ ))
#define __FuncEntered() SysDebug(( MID_EXCEPTION, "[%s] entered\n", __FUNCTION__ ))
#else
#define __NotImplemented() 
#define __NotRequired() 
#define __FuncEntered() 
#endif

} // namespace  WebControl

#endif // __IControl_Defined