/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		WebFrame.h
 * @brief		implement WebFrame of WebControl
 * @author	Sangheon Kim (sangheon77.kim@samsung.com)
 * @version	1.0
 * @date		2008.03.18	v1.0		Created
 */
#ifndef __WebFrame_Defined
#define __WebFrame_Defined

// WebKit/WebCore headers
#include "Frame.h"

// WebControl headers
#include "WebDefs.h"
#include "WebControlConfig.h"
//#include "WebFrameLoaderClient.h"
#include "HTMLFrameOwnerElement.h"

namespace	WebControl
{
class WebControl;
class WebFrameLoaderClient;

class WebFrame
{
public:
	/**
	* 
	*/
	static HRESULT New( WebControl* pWebControl, WebFrame **pFrame );
	static HRESULT New( WebControl* pWebControl, WebCore::HTMLFrameOwnerElement* element, WebFrame **pFrame );
	~WebFrame();



	WebCore::Frame* GetFrame() { return m_pFrame; }
	WebControl* GetWebControl() { return m_pWebControl; }
	bool IsMainFrame() { return m_bIsMainFrame; }
	void SetIsMainFrame( bool bIsMainFrame ) { m_bIsMainFrame = bIsMainFrame; }

private:
	WebFrame();

	HRESULT Construct( WebControl* pWebControl );
	HRESULT Construct( WebControl* pWebControl, WebCore::HTMLFrameOwnerElement* element );
	HRESULT Destruct();


	WebControl*						m_pWebControl;
	WebCore::Frame*				m_pFrame;
	WebFrameLoaderClient*	m_pClient;
	bool					m_bIsMainFrame;
};



} // namespace  WebFrame

#endif // __WebFrame_Defined