/**
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */

/**
 *  This file is about ECOM service.
 * 
 * @name        LibxmlECOM.c
 * @author      Zafar Hussain ( zafar.h@samsung.com )
 */

/*TBD: 
#include 
*/
#if defined(_JASMINE_ECOM)
#include "shp.h"
#include "tree.h"
#include "XmlString.h"
#include "BalPointers.h"
#include "LibxmlECOM.h"



static UINT32	__LibxmlAddRef(void);
static UINT32	__LibxmlRelease(void);
BOOL LibxmlDispatch(UINT32 action, ULONG param1, ULONG param2, void* pParam3);

TLibxml	gLibxml;
static ELibxml LibxmlVtbl;
static TLibxml* pSelf = &gLibxml;

/*
#if defined(_SHP_BROWSER_SFB)
#if defined	(_SHP_SIMUL)
BOOL		(*pSFBalInitialize)(void);
#endif
#endif
*/

/*
 *  __LibxmlConstruct .
 * 
 * @return      if succeed, return TRUE or FALSE.
 * @exception   In C, error code. In C++, exception to throw.
 * @see         related information ( function name, module name, etc )
 */
BOOL
__LibxmlConstruct(void)
{
	/*
	 * Hook ECOM interfaces and corresponding functions
	 */			
	LibxmlVtbl.AddRef					= __LibxmlAddRef;
	LibxmlVtbl.Release					= __LibxmlRelease;
	LibxmlVtbl.Dispatch					= LibxmlDispatch;
	
	LibxmlVtbl.GetProp					= xmlGetProp;
	LibxmlVtbl.Strcmp					= xmlStrcmp;
	LibxmlVtbl.NodeListGetString		= xmlNodeListGetString;
	LibxmlVtbl.ReadDoc					= xmlReadDoc;
	LibxmlVtbl.FreeDoc					= xmlFreeDoc;
	LibxmlVtbl.DocGetRootElement		= xmlDocGetRootElement;
	
	INIT_ECOM_VTBL(&gLibxml, ELibxml, LibxmlVtbl);   // Initialize the VTBL
	//__InitLibxml(); // Initialize SFBAL function pointers for use inside LIBXML
	return SysRegisterClass(NULL, CID_LIBXML, &gLibxml);
}

/*
 *  __WebControlDestruct is destruct.
 * 
 * @return      if succeed, return TRUE or FALSE.
 * @exception   In C, error code. In C++, exception to throw.
 * @see         related information ( function name, module name, etc )
 */
BOOL
__LibxmlDestruct(void)
{
	SysDebug((MID_BRSVC, "__LibxmlDestruct Called\n"));

	return SysUnregisterClass(NULL, CID_LIBXML);
}

/*
 *  These functions implement EBase interfaces
 * 
 * @return      if succeed, return count.
 * @exception   In C, error code. In C++, exception to throw.
 * @see         related information ( function name, module name, etc )
 */
static UINT32
__LibxmlAddRef(void)
{
	return ++pSelf->refCount;
}

/*
 *  This function decrement EBase interface.
 * 
 * @return      count
 * @exception   In C, error code. In C++, exception to throw.
 * @see         related information ( function name, module name, etc )
 */
static UINT32
__LibxmlRelease(void)
{
	if (--pSelf->refCount == 0)
	{
	}

	return pSelf->refCount;
}

/**
 *  This function dispatches WebControl services.
 * 
 * @param      action  [in] Specifies an action type to dispatch
 * @param      param1  [in] Specifies an action type to dispatch
 * @param      param2  [in] Specifies an action type to dispatch
 * @param      pParam3  [in] Specifies an action type to dispatch
 * @return	    if succeed, return TRUE or FALSE.
 * @exception  In C, error code. In C++, exception to throw.
 * @see        related information ( function name, module name, etc )
 */
BOOL
LibxmlDispatch(UINT32 action, ULONG param1, ULONG param2, void* pParam3)
{
	BOOL	bReturn = FALSE;

	switch (action)
	{
		case DLL_CREATE:
			bReturn = __LibxmlConstruct();
			return bReturn;


		case DLL_DELETE:
			bReturn = __LibxmlDestruct();
			return bReturn;
	}
	return FALSE;
}

#endif // _JASMINE_ECOM
/* @} */
