#ifndef _WM_CRAYON_H_
#define _WM_CRAYON_H_

#include "WmGrpConfig.h"
#include "WmGrpType.h"
#include "WmGrpGlobal.h"
#include "DevLCD.h"

#define RGB888ToCOLOR16( red, green, blue ) ((COLOR16)(((UCHAR)(blue>>3)|((WORD)((UCHAR)(green>>3))<<6))|(((WORD)(UCHAR)(red>>3))<<11)))
#define COLOR32ToRGB565( color32 )        RGB565( RED32( color32 ), GREEN32( color32 ), BLUE32( color32 ) )
#define RGB565( red, green, blue )		RGB888ToCOLOR16( red, green, blue )
#define RGB565Ex( color32 )				COLOR32ToRGB565( color32 )	
#define RED32( color32 )		   (UCHAR)( 0x00F8 & (color32 >> 16) )
#define GREEN32( color32 )		   (UCHAR)( 0x00F8 & (color32 >> 8) )
#define BLUE32( color32 )		   (UCHAR)( 0x00F8 & color32 )

BOOL    WmClearGC ( HGC hGC );
BOOL    WmClearGCRectArea ( HGC hGC, int rectX, int rectY, int rectW, int rectH );
BOOL	__WmSetFgColor ( HGC hGC, COLOR color );
BOOL	WmGetFgColor ( HGC hGC, COLOR* pColor );
BOOL	WmSetBgColor ( HGC hGC, COLOR color );
BOOL	WmInitGCAttrib ( HGC hGC );
BOOL	WmSetAntialiasingFlag ( HGC hGC, BOOL bAntialiasing );
BOOL	WmGetGCFrmbuf ( HGC hGC, COLOR** pFrmbuf );
WmGC*   WmGetGCPointer ( HGC hGC );
WmClip  WmSetClipRect ( HGC hGC, int rectX, int rectY, int rectW, int rectH );
BOOL	WmGetClipRect ( HGC hGC, WmRect* prcClip );
BOOL    WmSetLineWidth ( HGC hGC, int lineWidth );
BOOL	WmSetLineType ( HGC hGC, WmLineType	lineType );
BOOL	__WmSetDotLineInfo ( HGC hGC, int dot, int space );
BOOL	WmSetDashLineInfo ( HGC hGC, int length, UCHAR* pPattern );
BOOL    WmDrawLine ( HGC hGC, int startX, int startY, int endX, int endY );
BOOL	WmDrawRect ( HGC hGC, int rectX, int rectY, int rectW, int rectH );
BOOL    __WmDrawFilledRect ( HGC hGC, COLOR color, int rectX, int rectY, int rectW, int rectH );
BOOL    WmDrawFilledRect32 ( HGC hGC, COLOR color, int rectX, int rectY, int rectW, int rectH );
BOOL    WmDrawEllipse ( HGC hGC, int rectX, int rectY, int rectW, int rectH );
BOOL    WmDrawFilledEllipse ( HGC hGC, COLOR color, int rectX, int rectY, int rectW, int rectH );  
BOOL	WmDrawArc ( HGC hGC, int rectX, int rectY, int rectW, int rectH, int startAngle, int endAngle, WmArcType arcType );
BOOL	WmDrawFilledPolygon ( HGC hGC, COLOR color, WmPoint* pptPoint, int pointCount );

WmBitmap* WmCaptureBitmapOnBitmap ( int rectX, int rectY, int rectW, int rectH, WmBitmap* pbmSrc);
BOOL	  _WmFreeCapturedBitmap ( WmBitmap* pbmBitmap, char *szFileName, int nLine);

#define	WmFreeCapturedBitmap(pbmBitmap)				\
_WmFreeCapturedBitmap (pbmBitmap, __FILE__, __LINE__)
//
//
BOOL    __WmDrawBitmap ( HGC hGC, int rectX, int rectY, WmBitmap* pbmBitmap );
BOOL	WmDrawSubBitmap ( HGC hGC, int rectX, int rectY, WmBitmap* pbmBitmap, int srcX, int srcY, int srcW, int srcH );

BOOL    WmDrawScaledBitmap ( HGC hGC, int rectX, int rectY, int rectW, int rectH, WmBitmap* pbmBitmap );

BOOL	__WmFreeBitmap ( WmBitmap* pbmBitmap );
BOOL	WmDrawTransparentBitmapEx( HGC hGC, int posX, int posY, WmBitmap* pbmBitmap, USHORT* iAlpha);

BOOL    __WmSetFont ( HGC hGC, HFNT hFont );

int		WmGetFontMaxHeight ( HFNT hFont );

BOOL    __WmSetFontUnderline ( HGC hGC, BOOL bUnderline );
BOOL    WmDrawText ( HGC hGC, int x, int y, MCHAR* mszText );
BOOL    WmGetGCTextExtent ( HGC hGC, MCHAR* mszText, int* pWidth, int* pHeight ); 
BOOL    WmGetTextExtent ( HFNT hFont, MCHAR* mszText, int* pWidth, int* pHeight ); 
BOOL    WmGetTextExtentN ( HFNT hFont, MCHAR* mszText, int textLength, int* pWidth, int* pHeight );
BOOL	WmVerifyGC ( HGC hGC );

#define	WmCopyGC(hDestGC, destX, destY, hSrcGC, srcX, srcY, srcW, srcH) \

#define WmSetFgColor( hGC, color )	__WmSetFgColor( __WmGetHGC(hGC), color )	
#define WmSetDotLineInfo(  hGC,  dot,  space )		__WmSetDotLineInfo(  __WmGetHGC(hGC),  dot,  space )
#define WmDrawFilledRect(  hGC,  color,  rectX,  rectY,  rectW,  rectH )		\
						__WmDrawFilledRect(  __WmGetHGC(hGC),  color,  rectX,  rectY,  rectW,  rectH )

#define WmDrawBitmap( hGC, rectX, rectY, pbmBitmap )		\
						__WmDrawBitmap( __WmGetHGC(hGC), rectX, rectY, pbmBitmap )

BOOL	WmInitFont ( void );

#define WmSetFont(  hGC,  hFont )		__WmSetFont(  __WmGetHGC(hGC),  hFont )
#define WmSetFontUnderline(  hGC,  bUnderline )		__WmSetFontUnderline(  __WmGetHGC(hGC),  bUnderline )
#define WmDrawTextN(  hGC,  x,  y,  mszText,  textLength )		\

int		WmGetFontAscender( HFNT hFont, int nCharHeight );
int		WmGetFontDescender( HFNT hFont, int nCharHeight );

#endif