#ifndef _WM_ECOM_H_
#define _WM_ECOM_H_

#ifdef __cplusplus
extern "C" {
#endif 

ECOM_INTERFACE(EGWESCore)
{
	int		  (*GetFontDescender)			( HFNT hFont, int nCharHeight );
	int		  (*GetFontAscender)			( HFNT hFont, int nCharHeight );
	BOOL	  (*SetWindowTransparentMode)	( HWIN hWin, BOOL bUsed );
	int		  (*GetHGC)						(int uid);
	HGC		  (*CreateClientSubMemGCInternal) ( HWIN hWin, int bitsPerPixel, int rectX, int rectY, int rectW, int rectH, char * allocFile, int allocLine );
	HGC 	(*CreateWindowSubMemGCInternal) ( HWIN hWin, int bitsPerPixel, int rectX, int rectY, int rectW, int rectH, char * allocFile, int allocLine );
	BOOL      (*VerifyGC)				( HGC hGC );
	BOOL    (*ClearGC) ( HGC hGC );
	BOOL    (*ClearGCRectArea) ( HGC hGC, int rectX, int rectY, int rectW, int rectH );
	BOOL	(*GetGCFrmbuf) ( HGC hGC, COLOR** pFrmbuf );
	WmGC*   (*GetGCPointer) ( HGC hGC );

	BOOL	(*SetFgColor) ( HGC hGC, COLOR color );
	BOOL	(*GetFgColor) ( HGC hGC, COLOR* pColor );
	BOOL	(*SetBgColor) ( HGC hGC, COLOR color );
	BOOL	(*InitGCAttrib) ( HGC hGC );
	BOOL	(*SetAntialiasingFlag) ( HGC hGC, BOOL bAntialiasing );

	WmClip     (*SetClipRect) ( HGC hGC, int rectX, int rectY, int rectW, int rectH );
	BOOL	   (*GetClipRect) ( HGC hGC, WmRect* prcClip );
	BOOL       (*SetLineWidth) ( HGC hGC, int lineWidth );
	BOOL	   (*SetLineType) ( HGC hGC, WmLineType	lineType );
	BOOL	   (*SetDotLineInfo) ( HGC hGC, int dot, int space );
	BOOL	   (*SetDashLineInfo) ( HGC hGC, int length, UCHAR* pPattern );
	BOOL       (*DrawLine) ( HGC hGC, int startX, int startY, int endX, int endY );
	BOOL	   (*DrawRect) ( HGC hGC, int rectX, int rectY, int rectW, int rectH );
	BOOL       (*DrawFilledRect) ( HGC hGC, COLOR color, int rectX, int rectY, int rectW, int rectH );
	BOOL       (*DrawFilledRect32) ( HGC hGC, COLOR32 color, int rectX, int rectY, int rectW, int rectH );
	BOOL       (*DrawEllipse) ( HGC hGC, int rectX, int rectY, int rectW, int rectH );
	BOOL       (*DrawFilledEllipse) ( HGC hGC, COLOR color, int rectX, int rectY, int rectW, int rectH );  
	BOOL	   (*DrawArc) ( HGC hGC, int rectX, int rectY, int rectW, int rectH, int startAngle, int endAngle, WmArcType arcType );
	BOOL	   (*DrawFilledPolygon) ( HGC hGC, COLOR color, WmPoint* pptPoint, int pointCount );
	WmBitmap*  (*CaptureBitmapOnBitmapEx) ( int rectX, int rectY, int rectW, int rectH, WmBitmap* pbmSrc, char *szFileName, int nLine );
	BOOL	   (*FreeCapturedBitmap) ( WmBitmap* pbmBitmap, char *szFileName, int nLine );
	BOOL       (*DrawBitmap) ( HGC hGC, int rectX, int rectY, WmBitmap* pbmBitmap );
	BOOL	   (*DrawSubBitmap) ( HGC hGC, int rectX, int rectY, WmBitmap* pbmBitmap, int srcX, int srcY, int srcW, int srcH );
	BOOL       (*DrawScaledBitmap) ( HGC hGC, int rectX, int rectY, int rectW, int rectH, WmBitmap* pbmBitmap );
	BOOL	   (*FreeBitmap) ( WmBitmap* pbmBitmap );
	BOOL	(*DrawTransparentBitmapEx)( HGC hGC, int posX, int posY, WmBitmap* pbmBitmap, USHORT* iAlpha);
	BOOL    (*SetFont) ( HGC hGC, HFNT hFont );
	int		(*GetFontMaxHeight) ( HWIN hWin );
	BOOL    (*SetFontUnderline) ( HGC hGC, BOOL bUnderline );
	BOOL    (*DrawText) ( HGC hGC, int x, int y, MCHAR* mszText );
	BOOL    (*GetGCTextExtent) ( HGC hGC, MCHAR* pmszText, int* pWidth, int* pHeight ); 
	BOOL    (*GetTextExtent) ( HFNT hFont, MCHAR* pmszText, int* pWidth, int* pHeight ); 
	BOOL    (*GetTextExtentN) ( HFNT hFont, MCHAR* pmszText, int textLength, int* pWidth, int* pHeight );

	HGC	    (*CreateClientGC) ( HWIN hWin, char * allocFile, int allocLine );
	HGC     (*CreateClientSubGC) ( HWIN hWin, int rectX, int rectY, int rectW, int rectH, char * allocFile, int allocLine );
	HGC	    (*CreateWindowMemGC) ( HWIN hWin, char * allocFile, int allocLine );
	HGC     (*CreateWindowSubMemGC) ( HWIN hWin, int rectX, int rectY, int rectW, int rectH, char * allocFile, int allocLine );
	BOOL    (*DeleteGC) ( HGC hGC, BOOL bOverlay, char * freeFile, int freeLine );

	BOOL    (*ShowGC) ( HGC hGC );
	BOOL	(*ShowGCRectArea) ( HGC hGC, int rectX, int rectY, int rectW, int rectH );

	BOOL	(*Convert2PCode) ( MCHAR* pmszOutText, int outBufSize, char* szInText);
	BOOL	(*Convert2LCode) ( char* pszOutText, int outBufSize, MCHAR* mszInText);
	BOOL    (*ConvertPCode2UTF)( UCHAR* pszOutText, int outBufSize, MCHAR* mszInText, int charCount );
	BOOL	(*ConvertKoi8rCode2PCode)	( MCHAR* pmszOutText, int outBufSize, char*  szInText);
	BOOL	(*ConvertKoi8uCode2PCode)	( MCHAR* pmszOutText, int outBufSize, char*  szInText);
	BOOL	(*ConvertWin1256Code2PCode) ( MCHAR* pmszOutText, int outBufSize, char*  szInText);
	BOOL	(*ConvertWin1255Code2PCode) ( MCHAR* pmszOutText, int outBufSize, char*  szInText);
	BOOL	(*ConvertWin1251Code2PCode) ( MCHAR* pmszOutText, int outBufSize, char*  szInText);
	BOOL	(*ConvertLatin15Code2PCode) ( MCHAR* pmszOutText, int outBufSize, char*  szInText);	
	BOOL	(*ConvertLatin8Code2PCode)	( MCHAR* pmszOutText, int outBufSize, char*  szInText);
	BOOL	(*ConvertLatin7Code2PCode)	( MCHAR* pmszOutText, int outBufSize, char* szInText);
	BOOL	(*ConvertLatin5Code2PCode)	( MCHAR* pmszOutText, int outBufSize, char*  szInText);
	BOOL	(*ConvertLatin4Code2PCode)	( MCHAR* pmszOutText, int outBufSize, char*  szInText);
	BOOL	(*ConvertLatin3Code2PCode)	( MCHAR* pmszOutText, int outBufSize, char*  szInText);
	BOOL	(*ConvertLatin2Code2PCode)	( MCHAR* pmszOutText, int outBufSize, char*  szInText);
	BOOL	(*ConvertLatinCode2PCode)		( MCHAR* pmszOutText, int outBufSize, char*  szInText);

	int		(*Strlen) ( const MCHAR* mszInText );

	BOOL	(*CallNextKeyPressedHandler)(WmState* pState, WmEvent* pEvent);
	BOOL	(*CallNextNotifyHandler)(WmState* pState, WmEvent* pEvent);
	BOOL	(*DestroyWindow) ( HWIN hWin, BOOL bFirst, BOOL bInternal, char* szFileName, int nLine );
	BOOL	(*GetScreenMetrics) (WmScreenMetrics * pScreenMetric, WmScreen screen);
	BOOL	(*GetWindowClientRect) (HWIN hWin, WmRect* prcRect);
	HWIN	(*GetParentWindow) (HWIN hWin);
	HWIN	(*GetFocusWindow) ( WmScreen screen );
	BOOL	(*SetFocusWindow) (HWIN hWin);
	BOOL	(*SetWindowStyle) ( HWIN hWin, int style );
	int		(*GetWindowStyle) ( HWIN hWin );
	BOOL	(*SetWindowPos) (HWIN hWin, int rectX, int rectY);
	BOOL	(*SetWindowBgColor) (HWIN hWin, COLOR bgColor);
	BOOL	(*SetWindowFont) (HWIN hWin, HFNT hFont);
	BOOL	(*GetWindowType) ( HWIN hWin, int* pType );
	BOOL	(*IsWindowValid) ( HWIN hWin );

	WmRegion *	(*CreateRegion)(WmBox * rect, int size);
	void		(*InitRegion)(WmRegion *pReg, WmBox *rect, int size);
	void		(*DestroyRegion)(WmRegion *pReg);

	BOOL	(*IntersectRegion)(WmRegion *newReg, WmRegion *reg1, WmRegion *reg2);
	BOOL	(*UnionRegion)(WmRegion *newReg, WmRegion *reg1, WmRegion *reg2);
	BOOL	(*SubtractRegion)(WmRegion *regD, WmRegion *regM, WmRegion *regS);

	WmBox*		(*RegionExtents)(WmRegion* pReg);
};

#	define	WmGetFontDescender				(__WmGetVtbl()->GetFontDescender)
#	define	WmGetFontAscender				(__WmGetVtbl()->GetFontAscender)
#	define	WmSetWindowTransparentMode		(__WmGetVtbl()->SetWindowTransparentMode)
#	define	__WmGetHGC						(__WmGetVtbl()->GetHGC)
#	define  __WmCreateClientSubMemGCInternal  (__WmGetVtbl()->CreateClientSubMemGCInternal)
#	define  WmVerifyGC					(__WmGetVtbl()->VerifyGC)			
#	define WmClearGC							(__WmGetVtbl()->ClearGC)
#	define WmClearGCRectArea					(__WmGetVtbl()->ClearGCRectArea)
#	define WmGetGCFrmbuf						(__WmGetVtbl()->GetGCFrmbuf)
#	define WmGetGCPointer						(__WmGetVtbl()->GetGCPointer)
#	define __WmSetFgColor							(__WmGetVtbl()->SetFgColor)
#	define WmGetFgColor							(__WmGetVtbl()->GetFgColor)
#	define WmSetBgColor							(__WmGetVtbl()->SetBgColor)
#	define WmInitGCAttrib						(__WmGetVtbl()->InitGCAttrib)
#	define WmSetAntialiasingFlag				(__WmGetVtbl()->SetAntialiasingFlag)
#	define WmSetClipRect						(__WmGetVtbl()->SetClipRect)
#	define WmGetClipRect						(__WmGetVtbl()->GetClipRect)
#	define WmSetLineWidth						(__WmGetVtbl()->SetLineWidth)
#	define WmSetLineType						(__WmGetVtbl()->SetLineType)
#	define __WmSetDotLineInfo						(__WmGetVtbl()->SetDotLineInfo)
#	define WmSetDashLineInfo					(__WmGetVtbl()->SetDashLineInfo)
#	define WmDrawLine							(__WmGetVtbl()->DrawLine)
#	define WmDrawRect							(__WmGetVtbl()->DrawRect)
#	define __WmDrawFilledRect						(__WmGetVtbl()->DrawFilledRect)
#	define WmDrawFilledRect32						(__WmGetVtbl()->DrawFilledRect32)
#	define WmDrawEllipse						(__WmGetVtbl()->DrawEllipse)
#	define WmDrawFilledEllipse					(__WmGetVtbl()->DrawFilledEllipse)
#	define WmDrawArc							(__WmGetVtbl()->DrawArc)
#	define WmDrawFilledPolygon					(__WmGetVtbl()->DrawFilledPolygon)
#	define WmCaptureBitmapOnBitmap(rectX, rectY, rectW, rectH, pbmSrc) \
	(__WmGetVtbl()->CaptureBitmapOnBitmapEx(rectX, rectY, rectW, rectH, pbmSrc, __FILE__, __LINE__))
#	define _WmFreeCapturedBitmap					(__WmGetVtbl()->FreeCapturedBitmap)
#	define __WmDrawBitmap							(__WmGetVtbl()->DrawBitmap)
#	define WmDrawSubBitmap						(__WmGetVtbl()->DrawSubBitmap)
#	define WmDrawScaledBitmap					(__WmGetVtbl()->DrawScaledBitmap)
#	define __WmFreeBitmap							(__WmGetVtbl()->FreeBitmap)
#	define WmDrawTransparentBitmapEx( hGC, posX, posY, pbmBitmap, iAlpha)			\
						(__WmGetVtbl()->DrawTransparentBitmapEx( __WmGetHGC(hGC), posX, posY, pbmBitmap, iAlpha))
#	define __WmCreateWindowSubMemGCInternal (__WmGetVtbl()->CreateWindowSubMemGCInternal)
#	define __WmSetFont							(__WmGetVtbl()->SetFont)
#	define WmGetFontMaxHeight					(__WmGetVtbl()->GetFontMaxHeight)
#	define __WmSetFontUnderline					(__WmGetVtbl()->SetFontUnderline)
#	define WmDrawText							(__WmGetVtbl()->DrawText)
#	define WmGetGCTextExtent					(__WmGetVtbl()->GetGCTextExtent)
#	define WmGetTextExtent						(__WmGetVtbl()->GetTextExtent)
#	define WmGetTextExtentN						(__WmGetVtbl()->GetTextExtentN)
#	define __WmCreateClientGC						(__WmGetVtbl()->CreateClientGC)
#	define __WmCreateClientSubGC					(__WmGetVtbl()->CreateClientSubGC)
#	define __WmCreateWindowMemGC					(__WmGetVtbl()->CreateWindowMemGC)
#	define __WmCreateWindowSubMemGC				(__WmGetVtbl()->CreateWindowSubMemGC)
#	define __WmDeleteGC							(__WmGetVtbl()->DeleteGC)
#	define WmShowGC								(__WmGetVtbl()->ShowGC)
#	define WmShowGCRectArea						(__WmGetVtbl()->ShowGCRectArea)
#	define WmConvert2PCode						(__WmGetVtbl()->Convert2PCode)
#	define WmConvert2LCode						(__WmGetVtbl()->Convert2LCode)
#	define WmConvertPCode2UTF					(__WmGetVtbl()->ConvertPCode2UTF)
#	define WmConvertKoi8rCode2PCode				(__WmGetVtbl()->ConvertKoi8rCode2PCode)
#	define WmConvertKoi8uCode2PCode				(__WmGetVtbl()->ConvertKoi8uCode2PCode)
#	define WmConvertWin1256Code2PCode			(__WmGetVtbl()->ConvertWin1256Code2PCode)
#	define WmConvertWin1255Code2PCode			(__WmGetVtbl()->ConvertWin1255Code2PCode)
#	define WmConvertWin1251Code2PCode			(__WmGetVtbl()->ConvertWin1251Code2PCode)
#	define WmConvertLatin15Code2PCode			(__WmGetVtbl()->ConvertLatin15Code2PCode)
#	define WmConvertLatin8Code2PCode			(__WmGetVtbl()->ConvertLatin8Code2PCode)
#	define WmConvertLatin7Code2PCode			(__WmGetVtbl()->ConvertLatin7Code2PCode)
#	define WmConvertLatin5Code2PCode			(__WmGetVtbl()->ConvertLatin5Code2PCode)
#	define WmConvertLatin4Code2PCode			(__WmGetVtbl()->ConvertLatin4Code2PCode)
#	define WmConvertLatin3Code2PCode			(__WmGetVtbl()->ConvertLatin3Code2PCode)
#	define WmConvertLatin2Code2PCode			(__WmGetVtbl()->ConvertLatin2Code2PCode)
#	define WmConvertLatinCode2PCode				(__WmGetVtbl()->ConvertLatinCode2PCode)
#	define WmStrlen								(__WmGetVtbl()->Strlen)
#	define WmCallNextKeyPressedHandler			(__WmGetVtbl()->CallNextKeyPressedHandler)
#	define WmCallNextNotifyHandler				(__WmGetVtbl()->CallNextNotifyHandler)
#	define _WmDestroyWindow						(__WmGetVtbl()->DestroyWindow)
#	define WmGetScreenMetrics					(__WmGetVtbl()->GetScreenMetrics)
#	define WmGetWindowClientRect				(__WmGetVtbl()->GetWindowClientRect)
#	define WmGetParentWindow					(__WmGetVtbl()->GetParentWindow)
#	define _WmGetFocusWindow					(__WmGetVtbl()->GetFocusWindow)
#	define WmSetFocusWindow						(__WmGetVtbl()->SetFocusWindow)
#	define WmSetWindowStyle						(__WmGetVtbl()->SetWindowStyle)
#	define WmGetWindowStyle						(__WmGetVtbl()->GetWindowStyle)
#	define WmSetWindowPos						(__WmGetVtbl()->SetWindowPos)
#	define WmSetWindowBgColor					(__WmGetVtbl()->SetWindowBgColor)
#	define WmSetWindowFont						(__WmGetVtbl()->SetWindowFont)
#	define WmGetWindowType						(__WmGetVtbl()->GetWindowType)
#	define WmIsWindowValid						(__WmGetVtbl()->IsWindowValid)
#	define WmCreateRegion						(__WmGetVtbl()->CreateRegion)
#	define WmInitRegion							(__WmGetVtbl()->InitRegion)
#	define WmDestroyRegion						(__WmGetVtbl()->DestroyRegion)
#	define WmIntersectRegion					(__WmGetVtbl()->IntersectRegion)
#	define WmUnionRegion						(__WmGetVtbl()->UnionRegion)
#	define WmSubtractRegion						(__WmGetVtbl()->SubtractRegion)
#	define WmRegionExtents						(__WmGetVtbl()->RegionExtents)

typedef struct
{
	DECLARE_ECOM_VTBL(EGWESCore)
} TGWESCore;

extern TGWESCore	gwesCore;

#ifdef __cplusplus
}
#endif

#endif 